<?php
/**
*
* @package alphaPORTAL
* @version $Id: blog.php 47 2008-08-06 23:24:21Z harmlessgoat22 $
* @copyright (c) 2008 phpALPHA Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/alpha_blog');
$user->add_lang('mods/alpha');
$user->add_lang('posting');

if (!$alphaportal_enabled)
{
	trigger_error('PORTAL_NOT_ENABLED');
}

if (!$alphaportal_blog_enabled)
{
	trigger_error('BLOGS_NOT_ENABLED');
}

$blog_id = request_var('b', 0);
$user_id = request_var('u', 0);
$label_id = request_var('l', 0);
$comment_id = request_var('c', 0);
$editting_comment = false;

// For posting/editing/deleting comments
if (request_var('mode', '') == 'c')
{
	$action = request_var('action', '');
	switch ($action)
	{
		case 'post':
			if ($comment_id == 0)
			{
				if ($auth->acl_get('u_alpha_blog_comments_post'))
				{
					$comment_parse = utf8_normalize_nfc(request_var('message', '', true));
					$uid = $bitfield = $options = '';
					$allow_bbcode	= ($config['allow_bbcode'] && $auth->acl_get('u_alpha_blog_bbcode')) ? true : false;
					$allow_smilies	= ($config['allow_smilies'] && $auth->acl_get('u_alpha_blog_smilies')) ? true : false;
					$allow_urls		= ($config['allow_post_links']) ? true : false;
					generate_text_for_storage($comment_parse, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
					$sql_ary = array(
						'poster_id'			=> $user->data['user_id'],
						'blog_id'			=> request_var('b', 0),
						'post_time'			=> time(),
						'comment'			=> $comment_parse,
						'bbcode_uid'		=> $uid,
						'bbcode_bitfield'	=> $bitfield,
						'bbcode_options'	=> $options,
					);
					$sql = 'INSERT ' . ALPHA_BLOG_COMMENTS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
					$db->sql_query($sql);
		
					$sql = 'SELECT comment_count
						FROM ' . ALPHA_BLOG_POSTS_TABLE . '
						WHERE blog_id = ' . request_var('b', 0);
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);
					$sql_ary = array(
						'comment_count'		=> ++$row['comment_count'],
					);
					$sql = 'UPDATE ' . ALPHA_BLOG_POSTS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE blog_id = ' . request_var('b', 0);
					$db->sql_query($sql);
					trigger_error($user->lang['SUCCESSFUL_NEW_COMMENT'] . sprintf($user->lang['RETURN_BLOG'], '<a href="' . append_sid("{$phpbb_root_path}blog.$phpEx", 'b=' . $blog_id) . '">', '</a> '));
				}
				else
				{
					trigger_error($user->lang['PROPER_PERMISSIONS_POST_COMMENTS']);
				}
			}
			else
			{
				$sql_array = array(
					'SELECT'	=> 'b.poster_id, c.poster_id as comment_poster_id, c.comment, c.bbcode_uid',
					'FROM'		=> array(
						ALPHA_BLOG_POSTS_TABLE		=> 'b',
						ALPHA_BLOG_COMMENTS_TABLE	=> 'c',
					),
					'WHERE'		=> 'b.blog_id = c.blog_id AND c.comment_id = ' . $comment_id,
				);
				$sql = $db->sql_build_query('SELECT', $sql_array);
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
	
				if (($auth->acl_get('u_alpha_blog_comments_edit') && $user->data['user_id'] == $row['comment_poster_id']) || $auth->acl_get('m_alpha_blog_comments_edit'))
				{
					$comment_parse = utf8_normalize_nfc(request_var('message', '', true));
					$uid = $bitfield = $options = '';
					$allow_bbcode	= ($config['allow_bbcode'] && $auth->acl_get('u_alpha_blog_bbcode')) ? true : false;
					$allow_smilies	= ($config['allow_smilies'] && $auth->acl_get('u_alpha_blog_smilies')) ? true : false;
					$allow_urls		= ($config['allow_post_links']) ? true : false;
					generate_text_for_storage($comment_parse, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
					$sql_ary = array(
						'comment'			=> $comment_parse,
						'bbcode_uid'		=> $uid,
						'bbcode_bitfield'	=> $bitfield,
						'bbcode_options'	=> $options,
					);
					$sql = 'UPDATE ' . ALPHA_BLOG_COMMENTS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE comment_id = $comment_id";
					$db->sql_query($sql);

					trigger_error($user->lang['SUCCESSFUL_EDIT_COMMENT'] . sprintf($user->lang['RETURN_BLOG'], '<a href="' . append_sid("{$phpbb_root_path}blog.$phpEx", 'b=' . $blog_id) . '">', '</a> '));
				}
				else
				{
					trigger_error($user->lang['PROPER_PERMISSIONS_POST_COMMENTS']);
				}
			}

			return;
		break;

		case 'edit':
			$sql_array = array(
				'SELECT'	=> 'b.poster_id, c.poster_id as comment_poster_id, c.comment, c.bbcode_uid',
				'FROM'		=> array(
					ALPHA_BLOG_POSTS_TABLE		=> 'b',
					ALPHA_BLOG_COMMENTS_TABLE	=> 'c',
				),
				'WHERE'		=> 'b.blog_id = ' . $blog_id . ' AND c.comment_id = ' . $comment_id,
			);
			$sql = $db->sql_build_query('SELECT', $sql_array);
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			if (($auth->acl_get('u_alpha_blog_comments_edit') && $user->data['user_id'] == $row['comment_poster_id']) || $auth->acl_get('m_alpha_blog_comments_edit'))
			{
				decode_message($row['comment'], $row['bbcode_uid']);
				$template->assign_vars(array(
					'EDIT_COMMENT_ID'		=> $comment_id,
					'EDIT_COMMENT_CONTENT'	=> $row['comment'],
					'S_EDIT_COMMENT'		=> true,
				));
				$editting_comment = true;
			}
			else
			{
				trigger_error($user->lang['PROPER_PERMISSIONS_EDIT_COMMENTS']);
			}
		break;

		case 'delete':
			$sql = 'SELECT poster_id
				FROM ' . ALPHA_BLOG_POSTS_TABLE . '
				WHERE blog_id = ' . $blog_id;
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);
			if (($auth->acl_get('u_alpha_blog_comments_delete') && $user->data['user_id'] == request_var('u', 0)) || $auth->acl_get('m_alpha_blog_comments_delete') || ($auth->acl_get('u_alpha_blog_comments_delete_own') && $user->data['user_id'] == $row['poster_id']))
			{
				$sql = 'DELETE FROM ' . ALPHA_BLOG_COMMENTS_TABLE . ' WHERE comment_id = ' . request_var('c', 0);
				$db->sql_query($sql);
	
				$sql = 'SELECT comment_count
				FROM ' . ALPHA_BLOG_POSTS_TABLE . '
				WHERE blog_id = ' . $blog_id;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				$sql_ary = array(
					'comment_count'		=> --$row['comment_count'],
				);
				$sql = 'UPDATE ' . ALPHA_BLOG_POSTS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . ' WHERE blog_id = ' . $blog_id;
				$db->sql_query($sql);
				trigger_error($user->lang['SUCCESSFUL_DELETE_COMMENT'] . sprintf($user->lang['RETURN_BLOG'], '<a href="' . append_sid("{$phpbb_root_path}blog.$phpEx", 'b=' . $blog_id) . '">', '</a> '));
			}
			else
			{
				trigger_error($user->lang['PROPER_PERMISSIONS_DELETE_COMMENTS']);
			}
			return;
		break;
	}
}

// If we are viewing a single blog post
if ($blog_id <> 0)
{
	$sql_ary = array(
		'SELECT'	=> 'b.*, u.*, r.rating AS user_rating',
		'FROM'		=> array(
			ALPHA_BLOG_POSTS_TABLE			=> 'b',
			USERS_TABLE						=> 'u',
		),
		'LEFT_JOIN'	=> array(
			array(
				'FROM'		=> array(ALPHA_BLOG_RATINGS_TABLE	=> 'r'),
				'ON'		=> 'r.blog_id = b.blog_id AND r.user_id = ' . $user->data['user_id'],
			),
		),
		'WHERE'		=> 'u.user_id = b.poster_id
			AND b.blog_id = ' . $blog_id,
		'ORDER_BY'	=> 'b.post_time',
	);
	$sql = $db->sql_build_query('SELECT', $sql_ary);
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		// Voting
		$stars = request_var('s', 0);
		if ($stars <> 0 && $stars < 6)
		{
			if ($row['user_rating'])
			{
				// If they've already voted, update
				$sql_ary = array(
					'blog_id'				=> $blog_id,
					'user_id'				=> (int) $user->data['user_id'],
					'rating'				=> $stars,
				);
				$sql = 'UPDATE ' . ALPHA_BLOG_RATINGS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE blog_id = $blog_id AND user_id = " . $user->data['user_id'];
				$db->sql_query($sql);
			}
			else
			{
				// If not, insert
				$sql_ary = array(
					'blog_id'				=> $blog_id,
					'user_id'				=> $user->data['user_id'],
					'rating'				=> $stars,
				);
				$sql = 'INSERT INTO ' . ALPHA_BLOG_RATINGS_TABLE . $db->sql_build_array('INSERT', $sql_ary);
				$db->sql_query($sql);
			}
			// Update the average vote for the blog, so it doesn't have to be done on every page load.
			$total_rating = 0;
			$total_raters = 0;
			$sql = 'SELECT rating
				FROM ' . ALPHA_BLOG_RATINGS_TABLE . '
				WHERE blog_id = ' . $blog_id;
			$result_rate = $db->sql_query($sql);
			while ($rating_row = $db->sql_fetchrow($result_rate))
			{
				$total_rating += $rating_row['rating'];
				$total_raters += 1;
			}
			$db->sql_freeresult($result_rate);

			$sql_ary = array(
				'rating'				=> round($total_rating/$total_raters),
			);
			$sql = 'UPDATE ' . ALPHA_BLOG_POSTS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE blog_id = $blog_id";
			$db->sql_query($sql);
			$row['rating'] = round($total_rating/$total_raters);
		}
		$user_rating = ($stars <> 0) ? $stars : $row['user_rating'];
		//$rating = ($stars <> 0) ? $stars : (($row['user_rating']) ? $row['user_rating'] : $row['rating']);
		$rating = $row['rating'];

		$content = generate_text_for_display($row['content'], $row['bbcode_uid'], $row['bbcode_bitfield'], $row['bbcode_options']);
		$template->assign_block_vars('blog_row', array(
			'POST_SUBJECT'	 		=> censor_text($row['subject']),
			'MESSAGE'	 			=> censor_text($content),
			'POST_AUTHOR_FULL'		=> get_username_string('full', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
			'POST_AUTHOR_COLOUR'	=> get_username_string('colour', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
			'POST_AUTHOR'			=> get_username_string('username', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
			'U_POST_AUTHOR'			=> get_username_string('profile', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
			'U_POST'				=> append_sid("{$phpbb_root_path}blog.$phpEx", 'b=' . $row['blog_id']),
			'S_RATING'				=> $rating,
			'L_YOUR_VOTE'			=> ($user_rating) ? sprintf($user->lang['YOU_VOTED'], $user_rating) : '',

			'AUTHOR_AVATAR'			=> get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height']),
			'AUTHOR_POSTS'			=> ($row['user_posts']) ? $row['user_posts'] : '',
			'AUTHOR_BLOGS'			=> ($row['user_blogs']) ? $row['user_blogs'] : '',
			'AUTHOR_JOINED'			=> $user->format_date($row['user_regdate'], false, true),
			'AUTHOR_FROM'			=> ($row['user_from']) ? $row['user_from'] : '',
			'POST_TIME'				=> $user->format_date($row['post_time'], false, true),
			'U_EDIT'				=> (($auth->acl_get('u_alpha_blog_edit') && $user->data['user_id'] == $row['poster_id']) || $auth->acl_get('m_alpha_blog_edit')) ? append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=alpha_blog&mode=view_post&action=edit&b=' . $row['blog_id']) : '',
			'U_DELETE'				=> (($auth->acl_get('u_alpha_blog_delete') && $user->data['user_id'] == $row['poster_id']) || $auth->acl_get('m_alpha_blog_delete'))? append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=alpha_blog&mode=view_post&action=delete&b=' . $row['blog_id']) : '',
			'U_PM'					=> ($config['allow_privmsg'] && $auth->acl_get('u_sendpm') && ($row['user_allow_pm'] || $auth->acl_gets('a_', 'm_') || $auth->acl_getf_global('m_'))) ? append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=pm&amp;mode=compose&amp;u=' . $row['user_id']) : '',
			'U_EMAIL'				=> ($row['user_allow_viewemail']) ? (($config['board_email_form'] && $config['email_enable']) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=email&amp;u={{$row['user_id']}}") : ((($config['board_hide_emails'] && !$auth->acl_get('a_email')) ? '' : 'mailto:' . $row['user_email']))) : '',
			'U_WWW'					=> ($row['user_website']) ? $row['user_website'] : '',
			'U_MSN'					=> ($row['user_msnm'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=msnm&amp;u={$row['user_id']}") : '',
			'U_ICQ'					=> ($row['user_icq']) ? 'http://www.icq.com/people/webmsg.php?to=' . $row['user_icq'] : '',
			'U_YIM'					=> ($row['user_yim']) ? 'http://edit.yahoo.com/config/send_webmesg?.target=' . urlencode($row['user_yim']) . '&amp;.src=pg' : '',
			'U_AIM'					=> ($row['user_aim'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=aim&amp;u={$row['user_id']}") : '',
			'U_JABBER'				=> ($row['user_jabber'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=jabber&amp;u={$row['user_id']}") : '',
		));
		// Get the list of labels. $are_labels checks if there are any labels at all, so if there aren't, the template doesn't display "Labels: "
		$are_labels = false;
		$sql_ary = array(
			'SELECT'	=> 'l.name, l.label_id',
			'FROM'		=> array(
				ALPHA_BLOG_POST_LABELS_TABLE	=> 'bl',
				ALPHA_BLOG_LABELS_TABLE			=> 'l',
			),
			'WHERE'		=> 'bl.blog_id = ' . $row['blog_id'] . '
				AND l.label_id = bl.label_id',
		);
		$sql = $db->sql_build_query('SELECT', $sql_ary);
		$result_lab = $db->sql_query($sql);
		while ($labels_row = $db->sql_fetchrow($result_lab))
		{
			$are_labels = true;
			$template->assign_block_vars('blog_row.label_row', array(
				'LABEL'			=> $labels_row['name'],
				'U_LABEL'		=> append_sid("{$phpbb_root_path}blog.$phpEx", 'l=' . $labels_row['label_id']),
			));
		}
		$db->sql_freeresult($result_lab);
		$template->assign_var('LABELS', $are_labels);

		// Comments, the fun part. I love comments.
		$sql_ary = array(
			'SELECT'	=> 'u.*, c.*',
			'FROM'		=> array(
				ALPHA_BLOG_COMMENTS_TABLE		=> 'c',
				USERS_TABLE						=> 'u',
			),
			'WHERE'		=> 'c.blog_id = ' . $row['blog_id'] . '
				AND c.poster_id = u.user_id',
		);
		$sql = $db->sql_build_query('SELECT', $sql_ary);
		$result_com = $db->sql_query($sql);
		while ($comments_row = $db->sql_fetchrow($result_com))
		{
			$ranks = $cache->obtain_ranks();
			get_user_rank($row['user_rank'], $row['user_posts'], $rank['title'], $rank['image'], $rank['image_src']);
			$template->assign_block_vars('blog_row.comment_row', array(
				'MESSAGE'	 			=> censor_text(generate_text_for_display($comments_row['comment'], $comments_row['bbcode_uid'], $comments_row['bbcode_bitfield'], $comments_row['bbcode_options'])),
				'POST_AUTHOR_FULL'		=> get_username_string('full', $comments_row['poster_id'], $comments_row['username'], $comments_row['user_colour'], $comments_row['username']),
				'POST_AUTHOR_COLOUR'	=> get_username_string('colour', $comments_row['poster_id'], $comments_row['username'], $comments_row['user_colour'], $comments_row['username']),
				'POST_AUTHOR'			=> get_username_string('username', $comments_row['poster_id'], $comments_row['username'], $comments_row['user_colour'], $comments_row['username']),
				'U_POST_AUTHOR'			=> get_username_string('profile', $comments_row['poster_id'], $comments_row['username'], $comments_row['user_colour'], $comments_row['username']),
				'S_AUTHOR_COMMENT'		=> ($comments_row['poster_id'] == $row['poster_id']) ? true : false,
				'S_HIGHLIGHT_AUTHOR'	=> $config['alphaportal_highlight_author'],

				'AUTHOR_AVATAR'			=> get_user_avatar($comments_row['user_avatar'], $comments_row['user_avatar_type'], $comments_row['user_avatar_width'], $comments_row['user_avatar_height']),
				'AUTHOR_POSTS'			=> ($comments_row['user_posts']) ? $comments_row['user_posts'] : '',
				'AUTHOR_BLOGS'			=> ($comments_row['user_blogs']) ? $comments_row['user_blogs'] : '',
				'AUTHOR_JOINED'			=> $user->format_date($comments_row['user_regdate'], false, true),
				'AUTHOR_FROM'			=> ($comments_row['user_from']) ? $comments_row['user_from'] : '',
				'POST_TIME'				=> $user->format_date($comments_row['post_time'], false, true),
				'RANK_TITLE'			=> $rank['title'],
				'RANK_IMG'				=> $rank['image'],
				'RANK_IMG_SRC'			=> $rank['image_src'],
				'U_EDIT'				=> (($auth->acl_get('u_alpha_blog_comments_edit') && $user->data['user_id'] == $comments_row['poster_id']) || $auth->acl_get('m_alpha_blog_comments_edit')) ? append_sid("{$phpbb_root_path}blog.$phpEx", 'mode=c&action=edit&c=' . $comments_row['comment_id'] . '&u=' . $comments_row['user_id'] . '&b=' . $row['blog_id']) : '',
				'U_DELETE'				=> (($auth->acl_get('u_alpha_blog_comments_delete') && $user->data['user_id'] == $comments_row['poster_id']) || $auth->acl_get('m_alpha_blog_comments_delete') || ($auth->acl_get('u_alpha_blog_comments_delete_own') && $user->data['user_id'] == $row['poster_id']))? append_sid("{$phpbb_root_path}blog.$phpEx", 'mode=c&action=delete&c=' . $comments_row['comment_id'] . '&u=' . $comments_row['user_id'] . '&b=' . $row['blog_id']) : '',
				'U_PM'					=> ($config['allow_privmsg'] && $auth->acl_get('u_sendpm') && ($comments_row['user_allow_pm'] || $auth->acl_gets('a_', 'm_') || $auth->acl_getf_global('m_'))) ? append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=pm&amp;mode=compose&amp;u=' . $comments_row['user_id']) : '',
				'U_EMAIL'				=> ($comments_row['user_allow_viewemail']) ? (($config['board_email_form'] && $config['email_enable']) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=email&amp;u={$comments_row['user_id']}") : ((($config['board_hide_emails'] && !$auth->acl_get('a_email')) ? '' : 'mailto:' . $comments_row['user_email']))) : '',
				'U_WWW'					=> ($comments_row['user_website']) ? $comments_row['user_website'] : '',
				'U_MSN'					=> ($comments_row['user_msnm'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=msnm&amp;u={$comments_row['user_id']}") : '',
				'U_ICQ'					=> ($comments_row['user_icq']) ? 'http://www.icq.com/people/webmsg.php?to=' . $comments_row['user_icq'] : '',
				'U_YIM'					=> ($comments_row['user_yim']) ? 'http://edit.yahoo.com/config/send_webmesg?.target=' . urlencode($comments_row['user_yim']) . '&amp;.src=pg' : '',
				'U_AIM'					=> ($comments_row['user_aim'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=aim&amp;u={$comments_row['user_id']}") : '',
				'U_JABBER'				=> ($comments_row['user_jabber'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=jabber&amp;u={$comments_row['user_id']}") : '',
			));
		}
		$db->sql_freeresult($result_com);
	}
	$db->sql_freeresult($result);

	// Generate the smilies...gee, I wonder if the MOD team actually reads the comments...
	generate_smilies('inline', false);

	// Francis (Handyman) is a nub - oh, and this next bit of code puts some template variables out there...I know! Fascinating...
	$template->assign_vars(array(
		'VIEW_SINGLE_POST'		=> true,
		'U_COMMENT_ACTION'		=> ($editting_comment) ? append_sid("{$phpbb_root_path}blog.$phpEx", 'mode=c&action=post&b=' . $blog_id . '&c=' . $comment_id) : append_sid("{$phpbb_root_path}blog.$phpEx", 'mode=c&action=post&b=' . $blog_id),
		'S_USER_POST_COMMENTS'	=> ($auth->acl_get('u_alpha_blog_comments_post')) ? true : false,
		'S_CAN_VOTE'			=> ($auth->acl_get('u_alpha_blog_vote') && $user->data['is_registered']) ? true : false,

		'S_BBCODE_ALLOWED'			=> ($config['allow_bbcode'] && $auth->acl_get('u_alpha_blog_bbcode')) ? true : false,
		'S_BBCODE_QUOTE'			=> true,
		'S_BBCODE_IMG'				=> true,
		'S_LINKS_ALLOWED'			=> ($config['allow_post_links']) ? true : false,
		'S_BBCODE_FLASH'			=> ($config['allow_post_flash']) ? true : false,
		'S_SMILIES_ALLOWED'			=> ($config['allow_smilies'] && $auth->acl_get('u_alpha_blog_smilies')) ? true : false,
	));
}
else if ($user_id <> 0)
{
	// Get the blogs by user_id, if 'u' is given...
	get_blogs($user_id, 'user');
}
else if ($label_id <> 0)
{
	// Get the blogs by label_id, if 'l' is given...
	get_blogs($label_id, 'label');
}
else
{
	// Or, if there isn't any extension, or at least not 'b', 'u', or 'l', display the main blog page, which can be edited in the ACP
	include_sidebar('blog_main');
	$template->assign_var('S_BLOG_MAIN', true);
}

// Output page...and Francis is still a nub
page_header($user->lang['BLOG']);

$template->set_filenames(array(
	'body' => 'blog_body.html')
);

page_footer();

?>