<?php
/**
*
* @package alphaPORTAL
* @version $Id: ap_pages.php 39 2008-08-03 22:51:25Z harmlessgoat22 $
* @copyright (c) 2008 phpALPHA Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package alphaPORTAL
*/

class ap_pages_info
{
	function module()
	{
		return array(
			'filename'		=> 'ap_pages',
			'title'			=> 'AP_PAGES',
			'version'		=> '1.0.0',
			'modes'			=> array(
				'pages'		=> array('title' => 'AP_PAGES', 'auth' => 'acl_a_board', 'cat' => array('ACP_GENERAL_ALPHAPORTAL'), 'tpl' => 'alphaportal/pages', 'edit_tpl' => 'acp_alpha_modules_pages.html'),
				'welcome'	=> array('title' => 'AP_WELCOME', 'auth' => 'acl_a_board', 'cat' => array('ACP_GENERAL_ALPHAPORTAL'), 'tpl' => 'alphaportal/pages', 'edit_tpl' => 'acp_alpha_modules_pages.html'),
				//'code'		=> array('title' => 'AP_PAGES_CODE', 'auth' => 'acl_a_board', 'cat' => array('ACP_GENERAL_ALPHAPORTAL'), 'tpl' => 'alphaportal/pages', 'edit_tpl' => 'acp_alpha_modules_pages.html'),
			),
		);
	}

	function install($page_id)
	{ 
		global $db, $config;
		$action = request_var('action', '');
		if ($action == 'quickadd')
		{
			list($module_basename, $module_mode) = explode('::', request_var('quick_install', ''));
		}
		else if ($action == 'add')
		{
			$module_mode = request_var('module_mode', '');
		}

		// Safe guard in case someone puts '' as their value for Title of Content in the manual page creation.
		// It does not matter if they are blank after editting though - just something with the BBCodes.
		$title = (request_var('page_title', 'Test Title', true) == '') ? 'Test Title' : utf8_normalize_nfc(request_var('page_title', 'Test Title', true));
		$content = (request_var('page_content', 'Test Content', true) == '') ? 'Test Content' : request_var('page_content', 'Test Content', true);
		$in_menu = request_var('in_menu', 0);
		$style = request_var('style', 0);
		$welcome = ($module_mode == 'welcome') ? 1 : 0;

		$content_parse = utf8_normalize_nfc($content);
		$uid = $bitfield = $options = '';
		$allow_bbcode = $allow_urls = $allow_smilies = true;
		generate_text_for_storage($content_parse, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);

		$sql_ary = array(
			'page_id'			=> $page_id,
			'title'				=> $title,
			'content'			=> $content_parse,
			'bbcode_uid'		=> $uid,
			'bbcode_bitfield'	=> $bitfield,
			'bbcode_options'	=> $options,
			'in_menu'			=> $in_menu,
			'style'				=> $style,
		);
		$sql = 'INSERT ' . ALPHA_PAGES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
		$db->sql_query($sql);

		sidebar_set_case('', $page_id, $title);

		if ($welcome == 1)
		{
			$sql_ary = array(
				'group_id'				=> 1,
				'module_id'				=> $page_id,
				'auth_setting'			=> ACL_YES,
			);
			$sql = 'INSERT INTO ' . ACL_ALPHA_TABLE . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
		}
		else
		{
			acl_module_set_all($page_id);
		}

		add_log('admin', 'LOG_PAGE_NEW', $title);
	}

	function uninstall()
	{
		global $db;
		$page_id = request_var('m', 0);
		$sql = 'DELETE FROM ' . ALPHA_PAGES_TABLE . ' WHERE page_id = ' . $page_id;
		$db->sql_query($sql);
		$sql = 'DELETE FROM ' . ACL_ALPHA_TABLE . ' WHERE module_id = ' . $page_id;
		$db->sql_query($sql);
		sidebar_delete_case($page_id);
		add_log('admin', 'LOG_PAGE_DELETE', $page_id);
	}
	function edit($mode, $submit = false)
	{
		global $db, $template, $config;
		$module_id = request_var('m', '');
		$sql_array = array(
			'SELECT'	=> 'p.*, m.module_id',
			'FROM'		=> array(
				ALPHA_PAGES_TABLE		=> 'p',
				ALPHA_MODULES_TABLE		=> 'm',
			),
			'WHERE'		=> 'm.module_id = ' . $db->sql_escape($module_id) . ' AND
				p.page_id = m.module_id',
		);
		$sql = $db->sql_build_query('SELECT', $sql_array);
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		
		decode_message($row['content'], $row['bbcode_uid']);
		$template->assign_vars(array(
			'TITLE'			=> $row['title'],
			'CONTENT'		=> $row['content'],
			'IN_MENU'		=> $row['in_menu'],
			'STYLE'			=> $row['style'],
			//'CODE'			=> ($mode == 'code') ? true : false,
		));

		if ($submit)
		{
			$content = utf8_normalize_nfc(request_var('page_content', '', true));
			$uid = $bitfield = $options = '';
			$allow_bbcode = $allow_urls = $allow_smilies = true;
			generate_text_for_storage($content, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
			$title = utf8_normalize_nfc(request_var('page_title', '', true));
			$sql_ary = array(
				'page_id'			=> $module_id,
				'title'				=> $title,
				'content'			=> $content,
				'bbcode_uid'		=> $uid,
				'bbcode_bitfield'	=> $bitfield,
				'bbcode_options'	=> $options,
				'in_menu'			=> request_var('in_menu', 0),
				'style'				=> request_var('style', 0),
			);
			$sql = 'UPDATE ' . ALPHA_PAGES_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE page_id = $module_id";
			$db->sql_query($sql);

			add_log('admin', 'LOG_PAGE_EDIT', $title);
		}
	}
}

?>