<?php
/**
*
* @package alphaPORTAL
* @version $Id: functions_alpha.php 47 2008-08-06 23:24:21Z harmlessgoat22 $
* @copyright (c) 2008 phpALPHA Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* Gets everything setup for any given module category
*/
function include_sidebar($sidebar, $page_id = 0)
{
	global $db, $template, $phpbb_root_path, $phpEx, $config;

	$select_sidebar = 0;
	switch ($sidebar)
	{
		case 'left':
			$select_sidebar = 1;
		break;

		case 'right':
			$select_sidebar = 2;
		break;

		case 'combined':
			$select_sidebar = 3;
		break;

		case 'index':
			$select_sidebar = 4;
		break;

		case 'portal':
			$select_sidebar = 5;
		break;

		case 'pages':
			$select_sidebar = $page_id;
			if (!acl_module($page_id))
			{
				trigger_error('NO_AUTH_PAGE');
			}
		break;

		case 'blog_sidebar':
			$select_sidebar = 8;
		break;

		case 'blog_main':
			$select_sidebar = 9;
		break;
	}

	$modules_results = false;

	$sql = 'SELECT *
			FROM ' . ALPHA_MODULES_TABLE . "
			WHERE module_class = 'ap'
				AND module_basename <> ''
				AND module_enabled = 1
				AND parent_id = $select_sidebar
			ORDER BY left_id";
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		$info_class = "ap_{$row['module_basename']}_info";
		if (!class_exists($info_class))
		{
			include("{$phpbb_root_path}includes/ap/info/ap_{$row['module_basename']}.$phpEx");
		}
		$get_modules = new $info_class();
		$module_info = $get_modules->module();
		$module_mode = $row['module_mode'];

		$php_class_name = "ap_{$row['module_basename']}";
		if (!class_exists($php_class_name))
		{
			include("{$phpbb_root_path}includes/ap/{$module_info['filename']}.$phpEx");
		}
		$php_class = new $php_class_name();
		$php_class->module_data($row['module_mode'], $row['module_id']);
		$sidebar_caps = strtoupper($sidebar);

		if (!empty($module_info['modes'][$module_mode]['tpl']))
		{
			$template->set_filenames(array(
				"sidebar_{$sidebar}"    => $module_info['modes'][$module_mode]['tpl'] . '.html',
			));
			
			$include_file = $template->assign_display("sidebar_{$sidebar}", '', true);
			
			$template->assign_block_vars('include_modules', array(
				"S_INCLUDE_{$sidebar_caps}"		=> $include_file
			));
			$modules_results = true;
		}
		unset($info_class);
		unset($php_class);
	}
	$db->sql_freeresult($result);

	return $modules_results;
}

/**
* Checks if a sidebar has modules without including them - a simpler form of include_sidebar, main difference being, include_sidebar includes the sidebar, whereas this just checks for modules.
*/
function check_sidebar($sidebar, $page_id = 0)
{
	global $db, $template, $phpbb_root_path, $phpEx, $config;

	$select_sidebar = 0;
	switch ($sidebar)
	{
		case 'left':
			$select_sidebar = 1;
		break;

		case 'right':
			$select_sidebar = 2;
		break;

		case 'combined':
			$select_sidebar = 3;
		break;

		case 'index':
			$select_sidebar = 4;
		break;

		case 'portal':
			$select_sidebar = 5;
		break;

		case 'pages':
			$select_sidebar = $page_id;
		break;

		case 'blog_sidebar':
			$select_sidebar = 8;
		break;

		case 'blog_main':
			$select_sidebar = 9;
		break;
	}

	$module_results = false;

	$sql = 'SELECT *
			FROM ' . ALPHA_MODULES_TABLE . "
			WHERE module_class = 'ap'
				AND module_basename <> ''
				AND module_enabled = 1
				AND parent_id = $select_sidebar
			ORDER BY left_id";
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		$info_class = "ap_{$row['module_basename']}_info";
		if (!class_exists($info_class))
		{
			include("{$phpbb_root_path}includes/ap/info/ap_{$row['module_basename']}.$phpEx");
		}
		$get_modules = new $info_class();
		$module_info = $get_modules->module();
		$module_mode = $row['module_mode'];
		unset($info_class);
		unset($php_class);

		if (!empty($module_info['modes'][$module_mode]['tpl']))
		{
			$module_results = true;
			break;
		}
	}
	$db->sql_freeresult($result);

	return $module_results;
}

/**
* Checks if a page exists...as might be assumed by the title...by MOD validators, you never can tell with them...
*/
function page_exists($page_id)
{
	global $db;
	$sql = 'SELECT module_basename
		FROM ' . ALPHA_MODULES_TABLE . '
		WHERE module_id = ' . $page_id;
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	if ($row['module_basename'] == '')
	{
		return true;
	}
	else
	{
		return false;
	}
}

/**
* Puts all module config values into an array
*/
function create_module_config_array()
{
	global $db, $cache;
	$module_config = array();
	if (($module_config = $cache->get('alpha_config')) == false)
	{
		$sql = 'SELECT *
		FROM ' . ALPHA_MODULES_CONFIG_TABLE;
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			$module_config[$row['type'] . $row['module_id']] = $row['value'];
		}
		$db->sql_freeresult($result);

		$cache->put('alpha_config', $module_config);
	}
	return $module_config;
}

/**
* Set config value. Creates missing config entry.
*/
function set_module_config($module_id, $config_name, $config_value)
{
	global $db, $module_config, $cache;
	$sql_ary = array(
		'module_id'				=> $module_id,
		'type'					=> $config_name,
		'value'					=> $config_value,
	);
	$sql = 'UPDATE ' . ALPHA_MODULES_CONFIG_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE module_id = $module_id AND type = '$config_name'";
	$db->sql_query($sql);

	if (!$db->sql_affectedrows() && !isset($module_config[$config_name . $module_id]))
	{
		$sql_ary = array(
			'module_id'				=> $module_id,
			'type'					=> $config_name,
			'value'					=> $config_value,
		);
		$sql = 'INSERT INTO ' . ALPHA_MODULES_CONFIG_TABLE . $db->sql_build_array('INSERT', $sql_ary);
		$db->sql_query($sql);
	}
	$module_config[$config_name . $module_id] = $config_value;
	$cache->put('alpha_config', $module_config);
	return;
}

/**
* Deletes all module configs set for certain module
*/
function delete_module_config($module_id)
{
	global $db;
	$sql = 'DELETE FROM ' . ALPHA_MODULES_CONFIG_TABLE . " WHERE module_id = {$module_id}";
	$db->sql_query($sql);
}

/**
* Page Permissions - here goes nothing...
*/
function acl_module($module_id, $user_id = 0)
{
	global $db, $user;
	$user_id = ($user_id == 0) ? $user->data['user_id'] : $user_id;
	$auth_module = false;
	$sql_array = array(
		'SELECT'	=> 'a.auth_setting',
		'FROM'		=> array(
			ACL_ALPHA_TABLE			=> 'a',
			USER_GROUP_TABLE		=> 'g',
		),
		'WHERE'		=> 'a.module_id = ' . $module_id . ' AND a.group_id = g.group_id AND g.user_id = ' . $user_id,
	);
	$sql = $db->sql_build_query('SELECT', $sql_array);
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		if ($row['auth_setting'] == ACL_NEVER)
		{
			$auth_module = false;
			break;
		}
		else if ($row['auth_setting'] == ACL_YES)
		{
			$auth_module = true;
		}
	}
	$db->sql_freeresult($result);
	return $auth_module;
}

/**
* Sets all group permissions for any given page to "yes"
*/
function acl_module_set_all($auth_id, $auth_setting = ACL_YES)
{
	global $db, $user;
	$repeats = array();
	$sql = 'SELECT group_id, module_id, auth_setting
	FROM ' . ACL_ALPHA_TABLE;
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		$repeats[$row['module_id']][$row['group_id']] = $row['auth_setting'];
	}
	$db->sql_freeresult($result);

	$sql_ary = array(
		'auth_setting'			=> $auth_setting,
	);
	$sql = 'UPDATE ' . ACL_ALPHA_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE module_id = $auth_id";
	$db->sql_query($sql);

	$sql = 'SELECT group_id
		FROM ' . GROUPS_TABLE;
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result))
	{
		if (!isset($repeats[$auth_id][$row['group_id']]))
		{
			$sql_ary = array(
				'group_id'				=> $row['group_id'],
				'module_id'				=> $auth_id,
				'auth_setting'			=> $auth_setting,
			);
			$sql = 'INSERT INTO ' . ACL_ALPHA_TABLE . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);
		}
	}
	$db->sql_freeresult($result);
}

/**
* Adds a sidebar case (number of sidebars)
*/
function sidebar_set_case($page = '', $page_id = 0, $title = '', $sidebars = 4, $user_made = 1)
{
	global $db;
	if ($page_id <> 0)
	{
		$page = 'pages';
	}
	if ($sidebars == 4)
	{
		$sql = 'SELECT number
			FROM ' . ALPHA_SIDEBARS_TABLE . "
			WHERE page = 'pages' AND page_id = 0";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		$sidebars = $row['number'];
	}

	$sql_ary = array(
		'page'				=> str_replace('.php', '', $page),
		'page_id'			=> $page_id,
		'title'				=> $title,
		'number'			=> $sidebars,
		'user_made'			=> $user_made,
	);
	$sql = 'INSERT INTO ' . ALPHA_SIDEBARS_TABLE . $db->sql_build_array('INSERT', $sql_ary);
	$db->sql_query($sql);
}

/**
* Delete a sidebar case (number of sidebars)
*/
function sidebar_delete_case($page_id = 0)
{
	global $db;
	$sql = 'DELETE FROM ' . ALPHA_SIDEBARS_TABLE . ' WHERE page_id = ' . $page_id;
	$db->sql_query($sql);
}

/**
* Displays posts for alphaPORTAL through Handyman's Posts Anywhere MOD
*/
function posts_anywhere($id)
{
	if (!class_exists('posts_anywhere'))
	{
		global $phpbb_root_path, $phpEx;
		include($phpbb_root_path . 'includes/posts_anywhere.' . $phpEx);
	}

	$posts_anywhere = new posts_anywhere();
	$posts_anywhere->display_instance($id);
	unset($posts_anywhere);
}

function array_key_exists_recursive($key, $array)
{
	if (array_key_exists($key, $array))
	{
		return true;
	}

	foreach ($array as $value)
	{
		if (array_key_exists_recursive($key, $value))
		{
			return true;
		}
	}

	return false;
}

function array_key_find_recursive($key, $array, $this_array = array())
{
	if (array_key_exists_recursive($key, $array))
	{
		$this_array = array();
		foreach ($array as $that_key => $that_array)
		{
			if (array_key_exists_recursive($key, $that_array))
			{
				$this_array[$that_key] = array_key_find_recursive($key, $that_array, $this_array);
			}
		}
		return $this_array;
	}

	return false;
}

/*function array_depth($array, &$depth = 0)
{
	$_depth = 0;
	foreach ($array as $item)
	{
		if (is_array($item))
		{
			if (!$_depth)
			{
				$_depth++;
			}

			array_depth($item, $depth);
		}
	}

	$depth += $_depth;

	return $depth;
}*/

/**
* Get the pages for menu...includes simple and advanced pages, and links.
* This is probably the most complicated function I've ever written...so I have elected to NOT to include any comments other than this one...have fun!
* I'm sure you MOD validators won't have any trouble understanding it...
*/
function display_page_list($module_array, $module_info, $current_id, $depth = 0)
{
	global $user, $template, $phpbb_root_path, $phpEx, $config, $module_config;

	if (gettype($module_array) == 'array')
	{
		foreach ($module_array as $id => $modules)
		{
			// Ok, I guess I'm feeling bad for you guys...you get one comment
			if ($module_info[$id]['parent_id'] == 6 || ($current_id <> 0 && ($module_info[$id]['parent_id'] == $module_info[$current_id]['parent_id'] || $module_info[$id]['parent_id'] == $current_id || ($module_info[$id]['left_id'] < $module_info[$current_id]['left_id'] && $module_info[$id]['right_id'] > $module_info[$current_id]['right_id']))))
			{
				$link_url = '';
				$menu = (isset($module_info[$id]['in_menu'])) ? $module_info[$id]['in_menu'] : 0;
				if ($module_info[$id]['module_basename'] == 'pages' && !$menu)
				{
					continue;
				}

				// Ha! That was a useless comment, but this one will help...
				if ($module_info[$id]['module_mode'] == 'links')
				{
					$module_title = (isset($user->lang[$module_config['display_text' . $id]])) ? $user->lang[$module_config['display_text' . $id]] : $module_config['display_text' . $id];
	
					$board_url = $config['server_protocol'] . $config['server_name'] . $config['script_path'];

					if (isset($template->_rootref[$module_config['links' . $id]]))
					{
						$link_url = $template->_rootref[$module_config['links' . $id]];
					}
					elseif (!strstr($module_config['links' . $id], 'http://') || strstr($module_config['links' . $id], $board_url))
					{
						if (strstr($module_config['links' . $id], $board_url))
						{
							$url = explode('?', str_replace($board_url, '', $module_config['links' . $id]));
						}
						else
						{
							$url = explode('?', $module_config['links' . $id]);
						}

						// Oops, I forgot to tell you...Igor is a nub
						if (isset($url[1]) && $url[1] <> '')
						{
							$link_url = append_sid($phpbb_root_path . str_replace('php', $phpEx, $url[0]), $url[1]);
						}
						else
						{
							$link_url = append_sid($phpbb_root_path . str_replace('php', $phpEx, $url[0]));
						}
					}
					else
					{
						$link_url = $module_config['links' . $id];
					}
				}
				else
				{
					if (isset($module_info[$id]['has_modules']) || !isset($module_info[$id]['has_sub']))
					{
						$link_url = append_sid("{$phpbb_root_path}pages.$phpEx", 'p=' . $id);
					}
					else
					{
						foreach ($modules as $module_id => $module)
						{
							if ($link_url == '')
							{
								$link_url = append_sid("{$phpbb_root_path}pages.$phpEx", 'p=' . $module_id);
							}
						}
					}
					$module_title = (!empty($user->lang[$module_info[$id]['module_langname']])) ? $user->lang[$module_info[$id]['module_langname']] : $module_info[$id]['module_langname'];
				}
	
				$template->assign_block_vars('page_list', array(
					'TITLE'			=> $module_title,
					'U_VIEW_PAGE'	=> $link_url,
					'PADDING'		=> 10 * $depth,
					'TOP_LEVEL'		=> ($depth == 0) ? true : false,
				));
				display_page_list($modules, $module_info, $current_id, $depth + 1);
			}
		}
	}
}

/**
* Inserts into/updates alpha_portal table
*/
function portal_update($module_id = 0, $mode = 'insert', $forum_ids = array(2), $topic_ids = array(), $limit = 10, $charlimit = 1000, $signature = 0, $first_post = false, $user_info = 0, $info_order = 0)
{
	global $db;
	$sql_ary = array(
		'module_id'					=> $module_id,
		'forum_ids'					=> serialize($forum_ids),
		'topic_ids'					=> serialize($topic_ids),
		'post_limit'				=> $limit,
		'charlimit'					=> $charlimit,
		'first_post'				=> $first_post,
		'signature'					=> $signature,
		'user_info'					=> $user_info,
		'info_order'				=> $info_order,
	);

	if ($mode == 'insert')
	{
		$sql = 'INSERT INTO ' . ALPHA_PORTAL_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
		$db->sql_query($sql);
	}
	elseif ($mode == 'update')
	{
		$sql = 'UPDATE ' . ALPHA_PORTAL_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE module_id = $module_id";
		$db->sql_query($sql);
	}
	else
	{
		$sql = 'DELETE FROM ' . ALPHA_PORTAL_TABLE . ' WHERE module_id = ' . $module_id;
		$db->sql_query($sql);
	}
}

?>