<?php
/**
*
* @package ucp
* @version $Id: ucp_alpha_blog.php 39 2008-08-03 22:51:25Z harmlessgoat22 $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* ucp_alpha_blog
* UCP Blog
* @package ucp
*/
class ucp_alpha_blog
{
	var $p_master;
	var $u_action;

	function main($id, $mode)
	{
		global $template, $db, $auth, $user;
		global $phpbb_root_path, $phpEx, $config;
		$user->add_lang('mods/alpha_blog');
		$user->add_lang('mods/alpha');
		include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
		include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
		include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

		switch ($mode)
		{
			case 'posting':
				$this->tpl_name = 'posting_blog_layout';
				$this->page_title = 'UCP_ALPHA_BLOG';
				$user->add_lang('posting');
				generate_smilies('inline', 0);
				if (isset($_POST['post']))
				{
					$this->compose_blog(request_var('subject', '', true), request_var('message', '', true), 'post', request_var('label_list', '', true));
				}
				else if (isset($_POST['preview']))
				{
					$this->compose_blog(request_var('subject', '', true), request_var('message', '', true), 'preview', request_var('label_list', '', true));
				}
				//$this->compose_blog('Hey', 'This is really cool', 'post');
				$template->assign_vars(array(
					'S_BBCODE_ALLOWED'			=> ($config['allow_bbcode'] && $auth->acl_get('u_alpha_blog_bbcode')) ? true : false,
					'S_BBCODE_QUOTE'			=> true,
					'S_BBCODE_IMG'				=> true,
					'S_LINKS_ALLOWED'			=> ($config['allow_post_links']) ? true : false,
					'S_BBCODE_FLASH'			=> ($config['allow_post_flash']) ? true : false,
					'S_SMILIES_ALLOWED'			=> ($config['allow_smilies'] && $auth->acl_get('u_alpha_blog_smilies')) ? true : false,
					'S_SHOW_SMILEY_LINK'		=> true,
					'S_POST_ACTION'				=> $this->u_action,
					'S_SHOW_DRAFTS'				=> true,
					'BLOG_ACTION'				=> $user->lang['POSTING_BLOG'],
				));
				return;
			break;

			case 'view_post':
				$blog_id = request_var('b', 0);
				$user_id = request_var('u', $user->data['user_id']);
				if (!$auth->acl_get('m_alpha_blog_edit'))
				{
					$user_id = $user->data['user_id'];
				}

				$action = request_var('action', '');
				switch ($action)
				{
					case 'edit':
						$this->tpl_name = 'posting_blog_layout';
						$this->page_title = 'UCP_ALPHA_BLOG';

						$user->add_lang('posting');
						$sql = 'SELECT *
						FROM ' . ALPHA_BLOG_POSTS_TABLE . '
						WHERE blog_id = ' . $blog_id;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);

						if ($auth->acl_get('m_alpha_blog_edit') || ($user->data['user_id'] == $row['poster_id'] && $auth->acl_get('u_alpha_blog_edit')))
						{
							$labels = '';
							$sql_array = array(
								'SELECT'	=> 'l.name, p.*',
								'FROM'		=> array(
									ALPHA_BLOG_POST_LABELS_TABLE		=> 'p',
									ALPHA_BLOG_LABELS_TABLE				=> 'l',
								),
								'WHERE'		=> 'p.blog_id = ' . $blog_id . ' AND
									p.label_id = l.label_id',
							);
							$sql = $db->sql_build_query('SELECT', $sql_array);
							$result = $db->sql_query($sql);
							while ($labels_row = $db->sql_fetchrow($result))
							{
								$labels .= $labels_row['name'] . ', ';
							}
							$db->sql_freeresult($result);
	
							generate_smilies('inline', 0);
							decode_message($row['content'], $row['bbcode_uid']);
							$template->assign_vars(array(
								'S_BBCODE_ALLOWED'			=> ($config['allow_bbcode'] && $auth->acl_get('u_alpha_blog_bbcode')) ? true : false,
								'S_BBCODE_QUOTE'			=> true,
								'S_BBCODE_IMG'				=> true,
								'S_LINKS_ALLOWED'			=> ($config['allow_post_links']) ? true : false,
								'S_BBCODE_FLASH'			=> ($config['allow_post_flash']) ? true : false,
								'S_SMILIES_ALLOWED'			=> ($config['allow_smilies'] && $auth->acl_get('u_alpha_blog_smilies')) ? true : false,
								'S_SHOW_SMILEY_LINK'		=> true,
								'S_POST_ACTION'				=> $this->u_action . '&action=edit&b=' . $blog_id,
								'S_SHOW_DRAFTS'				=> true,
								'BLOG_ACTION'				=> $user->lang['EDITTING_BLOG'],
								'SUBJECT'					=> $row['subject'],
								'MESSAGE'					=> $row['content'],
								'LABELS'					=> $labels,
								
							));
							if (isset($_POST['post']))
							{
								$this->compose_blog(request_var('subject', '', true), request_var('message', '', true), 'edit', request_var('label_list', '', true), $blog_id);
							}
							else if (isset($_POST['preview']))
							{
								$this->compose_blog(request_var('subject', '', true), request_var('message', '', true), 'preview', request_var('label_list', '', true));
							}
						}
						else
						{
							trigger_error($user->lang['PROPER_PERMISSIONS_EDIT_BLOG']);
						}
						//$this->compose_blog('', '', 'delete', '', request_var('b', 0));
						return;
					break;

					case 'delete':
						$sql = 'SELECT poster_id
							FROM ' . ALPHA_BLOG_POSTS_TABLE . '
							WHERE blog_id = ' . $blog_id;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);
						if ($auth->acl_get('m_alpha_blog_delete') || ($user->data['user_id'] == $row['poster_id'] && $auth->acl_get('u_alpha_blog_delete')))
						{
							$this->compose_blog('', '', 'delete', '', request_var('b', 0));
						}
						else
						{
							trigger_error($user->lang['PROPER_PERMISSIONS_DELETE_BLOG']);
						}
						return;
					break;					

					case 'view':
					default:
						$this->tpl_name = 'ucp_blog_viewmessage';
						$this->page_title = 'UCP_ALPHA_BLOG';

						if (request_var('remove', 0) == 1)
						{
							$label_id = request_var('l', 0);
							$sql = 'DELETE FROM ' . ALPHA_BLOG_POST_LABELS_TABLE . ' WHERE blog_id = ' . $blog_id . ' AND label_id = ' . $label_id;
							$db->sql_query($sql);
						}
						else if (request_var('remove', 0) == 2)
						{
							$label_id = request_var('l', 0);
							$sql = 'SELECT *
								FROM ' . ALPHA_BLOG_POST_LABELS_TABLE . '
								WHERE blog_id = ' . $blog_id . ' AND label_id = ' . $label_id;
							$result = $db->sql_query($sql);
							$rowset = $db->sql_fetchrowset($result);

							if (sizeof($rowset) == 0)
							{
								$sql_ary = array(
									'blog_id'			=> $blog_id,
									'label_id'			=> $label_id,
								);
								$sql = 'INSERT ' . ALPHA_BLOG_POST_LABELS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
								$db->sql_query($sql);
							}
						}

						$sql_array = array(
							'SELECT'	=> 'u.*, b.*',
							'FROM'		=> array(
								ALPHA_BLOG_POSTS_TABLE		=> 'b',
								USERS_TABLE					=> 'u',
							),
							'WHERE'		=> 'b.blog_id = ' . $blog_id . ' AND
								b.poster_id = u.user_id',
						);
						$sql = $db->sql_build_query('SELECT', $sql_array);
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);

						$labels = $labels_any = false;
						$sql_array = array(
							'SELECT'	=> 'l.*, p.blog_id',
							'FROM'		=> array(
								ALPHA_BLOG_LABELS_TABLE				=> 'l',
							),
							'LEFT_JOIN'	=> array(
								array(
									'FROM'	=> array(ALPHA_BLOG_POST_LABELS_TABLE	=> 'p'),
									'ON'	=> 'p.blog_id = ' . $blog_id . ' AND p.label_id = l.label_id',
								),
							),
							'WHERE'		=> 'l.user_id = ' . $user_id
						);
						$sql = $db->sql_build_query('SELECT', $sql_array);
						$result = $db->sql_query($sql);
						while ($labels_row = $db->sql_fetchrow($result))
						{
							if ($labels_row['blog_id'] == $blog_id)
							{
								$template->assign_block_vars('label_row', array(
									'U_LABEL'			=> append_sid("{$phpbb_root_path}ucp.{$phpEx}", 'i=alpha_blog&mode=labels&action=view&l=' . $labels_row['label_id']),
									'U_REMOVE_LABEL'	=> append_sid("{$phpbb_root_path}ucp.{$phpEx}", 'i=alpha_blog&mode=view_post&action=view&remove=1&l=' . $labels_row['label_id'] . '&b=' . $labels_row['blog_id']),
									'LABEL'				=> $labels_row['name'],
								));
								$labels = true;
							}
							else
							{
								$template->assign_block_vars('label_row_all', array(
									'U_LABEL'			=> append_sid("{$phpbb_root_path}ucp.{$phpEx}", 'i=alpha_blog&mode=view_post&action=view&remove=2&l=' . $labels_row['label_id'] . '&b=' . $blog_id),
									'LABEL'				=> $labels_row['name'],
								));
								$labels_any = true;
							}
						}
						$db->sql_freeresult($result);

						if ($auth->acl_get('m_alpha_blog_edit') || $auth->acl_get('m_alpha_blog_delete') || $user->data['user_id'] == $row['poster_id'])
						{
							$content = generate_text_for_display($row['content'], $row['bbcode_uid'], $row['bbcode_bitfield'], $row['bbcode_options']);
							$template->assign_vars(array(
								'SUBJECT'	 			=> censor_text($row['subject']),
								'MESSAGE'	 			=> censor_text($content),
								'MESSAGE_AUTHOR_FULL'	=> get_username_string('full', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
								'MESSAGE_AUTHOR_COLOUR'	=> get_username_string('colour', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
								'MESSAGE_AUTHOR'		=> get_username_string('username', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
								'U_MESSAGE_AUTHOR'		=> get_username_string('profile', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
								'LABELS'				=> $labels,
								'LABELS_ALL'			=> $labels_any,
								'U_BLOG_POST'			=> append_sid($phpbb_root_path . 'blog.' . $phpEx, 'b=' . $blog_id),

								'AUTHOR_AVATAR'			=> get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height']),
								'AUTHOR_POSTS'			=> ($row['user_posts']) ? $row['user_posts'] : '',
								'AUTHOR_BLOGS'			=> ($row['user_blogs']) ? $row['user_blogs'] : '',
								'AUTHOR_JOINED'			=> $user->format_date($row['user_regdate'], false, true),
								'AUTHOR_FROM'			=> ($row['user_from']) ? $row['user_from'] : '',
								'POST_TIME'				=> $user->format_date($row['post_time'], false, true),
								'U_EDIT'				=> (($auth->acl_get('u_alpha_blog_edit') && $user->data['user_id'] == $row['poster_id']) || $auth->acl_get('m_alpha_blog_edit')) ? $this->u_action . '&action=edit&b=' . $blog_id : '',
								'U_DELETE'				=> (($auth->acl_get('u_alpha_blog_delete') && $user->data['user_id'] == $row['poster_id']) || $auth->acl_get('m_alpha_blog_delete'))? $this->u_action . '&action=delete&b=' . $blog_id : '',
								'U_PM'					=> ($config['allow_privmsg'] && $auth->acl_get('u_sendpm') && ($row['user_allow_pm'] || $auth->acl_gets('a_', 'm_') || $auth->acl_getf_global('m_'))) ? append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=pm&amp;mode=compose&amp;u=' . $row['user_id']) : '',
								'U_EMAIL'				=> ($row['user_allow_viewemail']) ? (($config['board_email_form'] && $config['email_enable']) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=email&amp;u={$row['user_id']}") : ((($config['board_hide_emails'] && !$auth->acl_get('a_email')) ? '' : 'mailto:' . $row['user_email']))) : '',
								'U_WWW'					=> ($row['user_website']) ? $row['user_website'] : '',
								'U_MSN'					=> ($row['user_msnm'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=msnm&amp;u={$row['user_id']}") : '',
								'U_ICQ'					=> ($row['user_icq']) ? 'http://www.icq.com/people/webmsg.php?to=' . $row['user_icq'] : '',
								'U_YIM'					=> ($row['user_yim']) ? 'http://edit.yahoo.com/config/send_webmesg?.target=' . urlencode($row['user_yim']) . '&amp;.src=pg' : '',
								'U_AIM'					=> ($row['user_aim'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=aim&amp;u={$row['user_id']}") : '',
								'U_JABBER'				=> ($row['user_jabber'] && $auth->acl_get('u_sendim')) ? append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=contact&amp;action=jabber&amp;u={$row['user_id']}") : '',
								'BLOG_ACTION'			=> $user->lang['VIEWING_BLOG_POST'],		
							));
						}
						else
						{
							trigger_error($user->lang['PROPER_PERMISSIONS_VIEW_BLOG']);
						}
						return;
					break;
				}

				return;
			break;

			case 'view_all':
				$this->tpl_name = 'ucp_blog_viewall';
				$this->page_title = 'UCP_ALPHA_BLOG';
				$label_ids = request_var('delete_label', array(0), true);
				$blog_ids = request_var('delete_blog', array(0), true);
				$user_id = request_var('u', $user->data['user_id']);
				if (!$auth->acl_get('m_alpha_blog_edit'))
				{
					$user_id = $user->data['user_id'];
				}

				if (sizeof($label_ids) <> 0 || sizeof($blog_ids) <> 0 || request_var('action', '') == 'delete')
				{
					if (confirm_box(true))
					{
						$blog_ids['checked'] = request_var('blog_ids_checked', array(0));
						$label_ids['checked'] = request_var('label_ids_checked', array(0));
						if (sizeof($label_ids['checked']) <> 0)
						{
							$first = true;
							$label_array = '(';
							foreach ($label_ids['checked'] as $lab)
							{
								$label_array .= ($first) ? $lab : ', ' . $lab;
								$first = false;
							}
							$label_array .= ')';
							$sql = 'DELETE FROM ' . ALPHA_BLOG_LABELS_TABLE . ' WHERE label_id IN ' . $label_array;
							$db->sql_query($sql);
							$sql = 'DELETE FROM ' . ALPHA_BLOG_POST_LABELS_TABLE . ' WHERE label_id IN ' . $label_array;
							$db->sql_query($sql);
						}

						if (sizeof($blog_ids['checked']) <> 0)
						{
							$first = true;
							$blog_array = '(';
							foreach ($blog_ids['checked'] as $blog)
							{
								$blog_array .= ($first) ? $blog : ', ' . $blog;
								$first = false;
							}
							$blog_array .= ')';
							$sql = 'DELETE FROM ' . ALPHA_BLOG_POSTS_TABLE . ' WHERE blog_id IN ' . $blog_array;
							$db->sql_query($sql);
							$sql = 'DELETE FROM ' . ALPHA_BLOG_POST_LABELS_TABLE . ' WHERE blog_id IN ' . $blog_array;
							$db->sql_query($sql);
							$sql = 'DELETE FROM ' . ALPHA_BLOG_COMMENTS_TABLE . ' WHERE blog_id IN ' . $blog_array;
							$db->sql_query($sql);
							$sql = 'DELETE FROM ' . ALPHA_BLOG_RATINGS_TABLE . ' WHERE blog_id IN ' . $blog_array;
							$db->sql_query($sql);
						}
						meta_refresh(3, $this->u_action);
						$redirect = sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '">', '</a> ');
						trigger_error($user->lang['SUCCESSFUL_DELETE_BLOG_LABEL'] . $redirect);
					}
					else
					{
						if (sizeof($label_ids) <> 0)
						{
							$first = true;
							$label_array = '(';
							foreach ($label_ids as $lab)
							{
								$label_array .= ($first) ? $lab : ', ' . $lab;
								$first = false;
							}
							$label_array .= ')';
							$sql = 'SELECT user_id, label_id
								FROM ' . ALPHA_BLOG_LABELS_TABLE . '
								WHERE label_id IN ' . $label_array;
							$result = $db->sql_query($sql);
							while ($row = $db->sql_fetchrow($result))
							{
								if ($auth->acl_get('m_alpha_blog_labels_delete') || ($user->data['user_id'] == $row['user_id'] && $auth->acl_get('u_alpha_blog_labels_delete')))
								{
									$label_ids['checked'][] = $row['label_id'];
								}
							}
							$db->sql_freeresult($result);
						}

						if (sizeof($blog_ids) <> 0)
						{
							$first = true;
							$blog_array = '(';
							foreach ($blog_ids as $blog)
							{
								$blog_array .= ($first) ? $blog : ', ' . $blog;
								$first = false;
							}
							$blog_array .= ')';
							$sql = 'SELECT poster_id, blog_id
								FROM ' . ALPHA_BLOG_POSTS_TABLE . '
								WHERE blog_id IN ' . $blog_array;
							$result = $db->sql_query($sql);
							while ($row = $db->sql_fetchrow($result))
							{
								if ($auth->acl_get('m_alpha_blog_labels_delete') || ($user->data['user_id'] == $row['poster_id'] && $auth->acl_get('u_alpha_blog_labels_delete')))
								{
									$blog_ids['checked'][] = $row['blog_id'];
								}
							}
							$db->sql_freeresult($result);
						}

						if (sizeof($label_ids['checked']) == 0 && sizeof($blog_ids['checked']) == 0)
						{
							trigger_error($user->lang['PROPER_PERMISSIONS_DELETE_BLOG_LABELS']);
						}

						confirm_box(false, $user->lang['CONFIRM_DELETE_BLOG_LABEL'], build_hidden_fields(array('blog_ids_checked' => $blog_ids['checked'], 'label_ids_checked' => $label_ids['checked'])));
						meta_refresh(3, $this->u_action);
						$message = $user->lang['RETURN_NO_DELETE_BLOG_LABEL'] . sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '">', '</a> ');
						trigger_error($message);
					}
				}
				$template->assign_vars(array(
					'BLOG_ACTION'		=> $user->lang['VIEWING_ALL_BLOGS'],
					'NEW_BLOG_IMG'		=> $user->img('button_new_blog', 'NEW_BLOG'),
					'U_NEW_BLOG'		=> append_sid($phpbb_root_path . 'ucp.' . $phpEx, 'i=alpha_blog&mode=posting'),
					'S_BLOG_ACTION'		=> $this->u_action . '&action=delete',
				));

				$sql = 'SELECT *
					FROM ' . ALPHA_BLOG_LABELS_TABLE . '
					WHERE user_id = ' . $user_id;
				$result = $db->sql_query($sql);
				while ($row = $db->sql_fetchrow($result))
				{
					// Send vars to template
					$template->assign_block_vars('label_row', array(
						'LABEL_ID'			=> $row['label_id'],
						'TITLE'				=> censor_text($row['name']),
						'U_VIEW_LABEL'		=> append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=alpha_blog&mode=labels&action=view&l=' . $row['label_id']),
					));
				}
				$db->sql_freeresult($result);

				$sql_array = array(
					'SELECT'	=> 'u.*, b.*',
					'FROM'		=> array(
						ALPHA_BLOG_POSTS_TABLE		=> 'b',
						USERS_TABLE					=> 'u',
					),
					'WHERE'		=> 'b.poster_id = u.user_id AND u.user_id = ' . $user_id,
				);
				$sql = $db->sql_build_query('SELECT', $sql_array);
				$result = $db->sql_query($sql);
				while ($row = $db->sql_fetchrow($result))
				{
					// Send vars to template
					$template->assign_block_vars('blog_row', array(
						'MESSAGE_AUTHOR_FULL'		=> get_username_string('full', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
						'MESSAGE_AUTHOR_COLOUR'		=> get_username_string('colour', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
						'MESSAGE_AUTHOR'			=> get_username_string('username', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
						'U_MESSAGE_AUTHOR'			=> get_username_string('profile', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
	
						'BLOG_ID'			=> $row['blog_id'],
						'SENT_TIME'			=> $user->format_date($row['post_time']),
						'SUBJECT'			=> censor_text($row['subject']),
						'ATTACH_ICON_IMG'	=> ($auth->acl_get('u_alpha_blog_download') && $row['attachment'] && $config['allow_blog_attach']) ? $user->img('icon_topic_attach', $user->lang['TOTAL_ATTACHMENTS']) : '',
	
						'U_VIEW_BLOG'		=> append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=alpha_blog&mode=view_post&action=view&amp;b=' . $row['blog_id']),
					));
				}
				$db->sql_freeresult($result);
				return;
			break;

			case 'labels':
				$action = request_var('action', '');
				$label_id = request_var('l', 0);
				$user_id = request_var('u', $user->data['user_id']);
				if (!$auth->acl_get('m_alpha_blog_edit'))
				{
					$user_id = $user->data['user_id'];
				}

				$template->assign_vars(array(
					'LABEL_NEW_IMG'			=> $user->img('button_new_label', 'NEW_LABEL'),
					'U_NEW_LABEL'			=> $this->u_action . '&action=add',
					'S_BLOG_ACTION'			=> $this->u_action . '&action=delete',
				));

				switch ($action)
				{
					case 'view':
						$this->tpl_name = 'ucp_blog_labels_view';
						$this->page_title = 'UCP_ALPHA_BLOG';
						$template->assign_var('BLOG_ACTION', $user->lang['VIEWING_LABEL']);
						$label_id = request_var('l', 0);
						$sql_array = array(
							'SELECT'	=> 'u.*, b.*',
							'FROM'		=> array(
								ALPHA_BLOG_POSTS_TABLE			=> 'b',
								ALPHA_BLOG_POST_LABELS_TABLE	=> 'l',
								USERS_TABLE						=> 'u',
							),
							'WHERE'		=> 'b.poster_id = u.user_id AND l.blog_id = b.blog_id AND l.label_id = ' . $label_id,
						);
						$sql = $db->sql_build_query('SELECT', $sql_array);
						$result = $db->sql_query($sql);
							while ($row = $db->sql_fetchrow($result))
							{
								if ($auth->acl_get('m_alpha_blog_labels_edit') || $auth->acl_get('m_alpha_blog_labels_delete') || $user->data['user_id'] == $row['user_id'])
								{
									// Send vars to template
									$template->assign_block_vars('blog_row', array(
										'MESSAGE_AUTHOR_FULL'		=> get_username_string('full', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
										'MESSAGE_AUTHOR_COLOUR'		=> get_username_string('colour', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
										'MESSAGE_AUTHOR'			=> get_username_string('username', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
										'U_MESSAGE_AUTHOR'			=> get_username_string('profile', $row['poster_id'], $row['username'], $row['user_colour'], $row['username']),
					
										'BLOG_ID'			=> $row['blog_id'],
										'SENT_TIME'			=> $user->format_date($row['post_time']),
										'SUBJECT'			=> censor_text($row['subject']),
										'ATTACH_ICON_IMG'	=> ($auth->acl_get('u_alpha_blog_download') && $row['attachment'] && $config['allow_blog_attach']) ? $user->img('icon_topic_attach', $user->lang['TOTAL_ATTACHMENTS']) : '',
					
										'U_VIEW_BLOG'		=> append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=alpha_blog&mode=view_post&action=view&amp;b=' . $row['blog_id']),
									));
								}
								else
								{
									trigger_error($user->lang['PROPER_PERMISSIONS_VIEW_LABEL']);
								}
							}
							$db->sql_freeresult($result);
						return;
					break;

					case 'add':
						$this->tpl_name = 'ucp_blog_labels_post';
						$this->page_title = 'UCP_ALPHA_BLOG';
						if (isset($_POST['post']))
						{
							$this->compose_blog(request_var('label_list', '', true), '', 'post', '', 0, 1);
						}
						$template->assign_var('ADDING_LABELS', true);
						return;
					break;

					case 'edit':
						$this->tpl_name = 'ucp_blog_labels_post';
						$this->page_title = 'UCP_ALPHA_BLOG';
						$sql = 'SELECT name, user_id
						FROM ' . ALPHA_BLOG_LABELS_TABLE . '
						WHERE label_id = ' . $label_id;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);

						$template->assign_vars(array(
							'ADDING_LABELS'		=> false,
							'LABEL'				=> $row['name'],
						));
						if ($auth->acl_get('m_alpha_blog_labels_edit') || $user->data['user_id'] == $row['user_id'])
						{
							if (isset($_POST['post']))
							{
								$this->compose_blog(request_var('label', '', true), '', 'edit', '', $label_id, 1);
							}
						}
						else
						{
							trigger_error($user->lang['PROPER_PERMISSIONS_EDIT_LABEL']);
						}
						return;
					break;

					case 'delete':
						$this->tpl_name = 'ucp_blog_labels_viewall';
						$this->page_title = 'UCP_ALPHA_BLOG';
						if ($label_id == 0)
						{
							$label_id = request_var('delete', array(0));
							if (sizeof($label_id) == 0)
							{
								$label_id = request_var('labels', array(0));
							}
							$first = true;
							$label_array = '(';
							foreach ($label_id as $lab)
							{
								$label_array .= ($first) ? $lab : ', ' . $lab;
								$first = false;
							}
							$label_array .= ')';
							$label_ids = array();
							$sql = 'SELECT user_id, label_id
								FROM ' . ALPHA_BLOG_LABELS_TABLE . '
								WHERE label_id IN ' . $label_array;
							$result = $db->sql_query($sql);
							while ($row = $db->sql_fetchrow($result))
							{
								if ($auth->acl_get('m_alpha_blog_labels_delete') || ($user->data['user_id'] == $row['user_id'] && $auth->acl_get('u_alpha_blog_labels_delete')))
								{
									$label_ids[] = $row['label_id'];
								}
							}
							$db->sql_freeresult($result);
							if (sizeof($label_ids) == 0)
							{
								trigger_error($user->lang['PROPER_PERMISSIONS_DELETE_LABEL']);
							}
							$this->compose_blog('', '', 'delete', '', $label_ids, 1, 1);
						}
						else
						{
							$sql = 'SELECT user_id
								FROM ' . ALPHA_BLOG_LABELS_TABLE . '
								WHERE label_id = ' . $label_id;
							$result = $db->sql_query($sql);
							$row = $db->sql_fetchrow($result);
							$db->sql_freeresult($result);
							if ($auth->acl_get('m_alpha_blog_labels_delete') || ($user->data['user_id'] == $row['user_id'] && $auth->acl_get('u_alpha_blog_labels_delete')))
							{
								$this->compose_blog('', '', 'delete', '', $label_id, 1);
							}
							else
							{
								trigger_error($user->lang['PROPER_PERMISSIONS_DELETE_LABEL']);
							}
						}
						return;
					break;
					
					case 'view_all':
					default:
						$this->tpl_name = 'ucp_blog_labels_viewall';
						$this->page_title = 'UCP_ALPHA_BLOG';
						$user_id = request_var('u', $user->data['user_id']);
						if (!$auth->acl_get('m_alpha_blog_edit'))
						{
							$user_id = $user->data['user_id'];
						}

						$template->assign_vars(array(
							'BLOG_ACTION'		=> $user->lang['VIEWING_ALL_LABELS'],
							'S_EDIT'			=> ($user->data['user_id'] == $user_id || $auth->acl_get('m_alpha_blog_labels_edit')) ? true : false,
						));
						$sql = 'SELECT *
							FROM ' . ALPHA_BLOG_LABELS_TABLE . '
							WHERE user_id = ' . $user_id;
						$result = $db->sql_query($sql);
						while ($row = $db->sql_fetchrow($result))
						{
							// Send vars to template
							$template->assign_block_vars('label_row', array(
								'LABEL_ID'			=> $row['label_id'],
								'TITLE'				=> censor_text($row['name']),
								'U_EDIT'			=> $this->u_action . '&action=edit&l=' . $row['label_id'],
								'U_VIEW_LABEL'		=> $this->u_action . '&action=view&l=' . $row['label_id'],
							));
						}
						$db->sql_freeresult($result);
						return;
					break;
				}
				return;
			break;
		}
	}
	
	function compose_blog($subject, $content, $action = 'post', $labels = '', $blog_id = 0, $is_label = 0, $multiple = 0)
	{
		global $template, $db, $auth, $user;
		global $phpbb_root_path, $phpEx, $config;

		switch ($action)
		{
			case 'post':
			case 'save':
				$content_parse = utf8_normalize_nfc($content);
				$uid = $bitfield = $options = '';
				$allow_bbcode	= ($config['allow_bbcode'] && $auth->acl_get('u_alpha_blog_bbcode')) ? true : false;
				$allow_smilies	= ($config['allow_smilies'] && $auth->acl_get('u_alpha_blog_smilies')) ? true : false;
				$allow_urls		= ($config['allow_post_links']) ? true : false;
				generate_text_for_storage($content_parse, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);

				if ($is_label == true)
				{
					$labels_exist = array();
					$sql = 'SELECT name
						FROM ' . ALPHA_BLOG_LABELS_TABLE . "
						WHERE user_id = {$user->data['user_id']}";
					$result = $db->sql_query($sql);
					$rowset = $db->sql_fetchrowset($result);
					foreach ($rowset as $key => $row)
					{
						$labels_exist[] = strtolower($row['name']);
					}

					$subject = str_replace(', ', ',', utf8_normalize_nfc($subject));
					$labels_split = explode(',', $subject);
					foreach ($labels_split as $label)
					{
						if (!in_array(strtolower($label), $labels_exist))
						{
							$sql_ary = array(
								'user_id'			=> $user->data['user_id'],
								'name'				=> $label,
							);
							$sql = 'INSERT ' . ALPHA_BLOG_LABELS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
							$db->sql_query($sql);
							$labels_exist[] = $label;
						}
					}
					meta_refresh(3, $this->u_action);
					$redirect = sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '">', '</a> ');
					trigger_error($user->lang['SUCCESSFUL_NEW_LABEL'] . $redirect);
				}
				else
				{	
					$sql_ary = array(
						'poster_id'			=> $user->data['user_id'],
						'post_time'			=> time(),
						'subject'			=> utf8_normalize_nfc($subject),
						'content'			=> $content_parse,
						'bbcode_uid'		=> $uid,
						'bbcode_bitfield'	=> $bitfield,
						'bbcode_options'	=> $options,
					);
					if ($action == 'save')
					{
						$sql_ary['draft'] = 1;
					}
					$sql = 'INSERT ' . ALPHA_BLOG_POSTS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
					$db->sql_query($sql);
					$blog_id = $db->sql_nextid();
	
					$sql = 'SELECT user_blogs
						FROM ' . USERS_TABLE . "
						WHERE user_id = {$user->data['user_id']}";
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);
					$sql_ary = array(
						'user_blogs'		=> ++$row['user_blogs'],
					);
					$sql = 'UPDATE ' . USERS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE user_id = {$user->data['user_id']}";
					$db->sql_query($sql);
	
					if ($labels <> '')
					{
						$labels = str_replace(', ', ',', $labels);
						$labels_split = explode(',', $labels);
						$user_label = array();
						$label_names = array();
						$sql = 'SELECT label_id, user_id, name
							FROM ' . ALPHA_BLOG_LABELS_TABLE;
						$result = $db->sql_query($sql);
						while ($row = $db->sql_fetchrow($result))
						{
							if ($row['user_id'] == $user->data['user_id'])
							{
								$user_label[strtolower($row['name'])] = $row['label_id'];
								$label_names[] = strtolower($row['name']);
							}
						}
						$db->sql_freeresult($result);
						foreach ($labels_split as $label)
						{
							if (in_array(strtolower($label), $label_names))
							{
								$sql_ary = array(
									'label_id'			=> $user_label[strtolower($label)],
									'blog_id'			=> $blog_id,
								);
								$sql = 'INSERT ' . ALPHA_BLOG_POST_LABELS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
								$db->sql_query($sql);
							}
						}
					}
					meta_refresh(3, $this->u_action);
					$redirect = sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '">', '</a> ');
					trigger_error($user->lang['SUCCESSFUL_NEW_BLOG'] . $redirect);
				}
				return;
			break;

			case 'edit':
			case 'loaded':
				if ($is_label == true)
				{
					$sql_ary = array(
						'user_id'			=> $user->data['user_id'],
						'name'				=> $subject,
					);
					$sql = 'UPDATE ' . ALPHA_BLOG_LABELS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE label_id = $blog_id";
					$db->sql_query($sql);
					trigger_error($user->lang['SUCCESSFUL_EDIT_LABEL'] . sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '&l=' . $blog_id . '">', '</a> '));
				}
				else
				{
					$content_parse = utf8_normalize_nfc($content);
					$uid = $bitfield = $options = '';
					$allow_bbcode	= ($config['allow_bbcode'] && $auth->acl_get('u_alpha_blog_bbcode')) ? true : false;
					$allow_smilies	= ($config['allow_smilies'] && $auth->acl_get('u_alpha_blog_smilies')) ? true : false;
					$allow_urls		= ($config['allow_post_links']) ? true : false;
					generate_text_for_storage($content_parse, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
			
					$sql_ary = array(
						'post_time'			=> time(),
						'subject'			=> utf8_normalize_nfc($subject),
						'content'			=> $content_parse,
						'bbcode_uid'		=> $uid,
						'bbcode_bitfield'	=> $bitfield,
						'bbcode_options'	=> $options,
					);
					if ($action == 'loaded')
					{
						$sql_ary['draft'] = 0;
					}
					$sql = 'UPDATE ' . ALPHA_BLOG_POSTS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE blog_id = $blog_id";
					$db->sql_query($sql);
					trigger_error($user->lang['SUCCESSFUL_EDIT_BLOG'] . sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '&b=' . $blog_id . '">', '</a> '));
				}
				return;
			break;
			
			case 'preview':
				$content_parse = utf8_normalize_nfc($content);
				$uid = $bitfield = $options = '';
				$allow_bbcode	= ($config['allow_bbcode'] && $auth->acl_get('u_alpha_blog_bbcode')) ? true : false;
				$allow_smilies	= ($config['allow_smilies'] && $auth->acl_get('u_alpha_blog_smilies')) ? true : false;
				$allow_urls		= ($config['allow_post_links']) ? true : false;
				generate_text_for_storage($content_parse, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
				$content_unparse = generate_text_for_display($content_parse, $uid, $bitfield, $options);

				$template->assign_vars(array(
					'PREVIEW_SUBJECT'	 	=> $subject,
					'PREVIEW_MESSAGE'	 	=> $content_unparse,
					'S_DISPLAY_PREVIEW'		=> true,
					'MESSAGE'				=> $content,
					'SUBJECT'				=> $subject,
					'LABELS'				=> $labels,
				));
				return;
			break;
			
			case 'delete':
				if ($multiple == 0)
				{
					if ($is_label == true)
					{
						if (confirm_box(true))
						{
							$sql = 'DELETE FROM ' . ALPHA_BLOG_LABELS_TABLE . ' WHERE label_id = ' . $blog_id;
							$db->sql_query($sql);
							$sql = 'DELETE FROM ' . ALPHA_BLOG_POST_LABELS_TABLE . ' WHERE label_id = ' . $blog_id;
							$db->sql_query($sql);
							meta_refresh(3, $this->u_action);
							$redirect = sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '">', '</a> ');
							trigger_error($user->lang['SUCCESSFUL_DELETE_LABEL'] . $redirect);
						}
						else
						{
							confirm_box(false, $user->lang['CONFIRM_DELETE_LABEL'], build_hidden_fields(array()));
							meta_refresh(3, $this->u_action . '&b=' . $blog_id);
							$message = $user->lang['RETURN_NO_DELETE_LABEL'] . sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '&b=' . $blog_id . '">', '</a> ');
							trigger_error($message);
						}
					}
					else
					{	
						if (confirm_box(true))
						{
							$sql = 'DELETE FROM ' . ALPHA_BLOG_POSTS_TABLE . ' WHERE blog_id = ' . $blog_id;
							$db->sql_query($sql);
							$sql = 'DELETE FROM ' . ALPHA_BLOG_POST_LABELS_TABLE . ' WHERE blog_id = ' . $blog_id;
							$db->sql_query($sql);
							$sql = 'DELETE FROM ' . ALPHA_BLOG_COMMENTS_TABLE . ' WHERE blog_id = ' . $blog_id;
							$db->sql_query($sql);
							$sql = 'DELETE FROM ' . ALPHA_BLOG_RATINGS_TABLE . ' WHERE blog_id = ' . $blog_id;
							$db->sql_query($sql);
							meta_refresh(3, append_sid($phpbb_root_path . 'ucp.' . $phpEx, 'i=alpha_blog&mode=view_all'));
							$redirect = sprintf($user->lang['RETURN_BLOG'], '<a href="' . append_sid($phpbb_root_path . 'ucp.' . $phpEx, 'i=alpha_blog&mode=view_all') . '">', '</a> ');
							trigger_error($user->lang['SUCCESSFUL_DELETE_BLOG'] . $redirect);
						}
						else
						{
							confirm_box(false, $user->lang['CONFIRM_DELETE_BLOG'], build_hidden_fields(array()));
							meta_refresh(3, $this->u_action . '&b=' . $blog_id);
							$message = $user->lang['RETURN_NO_DELETE_BLOG'] . sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '&b=' . $blog_id . '">', '</a> ');
							trigger_error($message);
						}
					}
				}
				else
				{
					if ($is_label == true)
					{
						if (confirm_box(true))
						{
							$blog_id = request_var('labels', array(0));
							foreach ($blog_id as $label)
							{
								$sql = 'DELETE FROM ' . ALPHA_BLOG_LABELS_TABLE . ' WHERE label_id = ' . $label;
								$db->sql_query($sql);
								$sql = 'DELETE FROM ' . ALPHA_BLOG_POST_LABELS_TABLE . ' WHERE label_id = ' . $label;
								$db->sql_query($sql);
							}
							meta_refresh(3, $this->u_action);
							$redirect = sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '">', '</a> ');
							trigger_error($user->lang['SUCCESSFUL_DELETE_LABEL'] . $redirect);
						}
						else
						{
							confirm_box(false, $user->lang['CONFIRM_DELETE_LABEL'], build_hidden_fields(array('labels'	=> $blog_id)));
							meta_refresh(3, $this->u_action . '&b=' . $blog_id);
							$message = $user->lang['RETURN_NO_DELETE_LABEL'] . sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '&b=' . $blog_id . '">', '</a> ');
							trigger_error($message);
						}
					}
					else
					{	
						if (confirm_box(true))
						{
							$blog_id = request_var('blogs', array(0));
							foreach ($blog_id as $blog)
							{
								$sql = 'DELETE FROM ' . ALPHA_BLOG_POSTS_TABLE . ' WHERE blog_id = ' . $blog;
								$db->sql_query($sql);
								$sql = 'DELETE FROM ' . ALPHA_BLOG_POST_LABELS_TABLE . ' WHERE blog_id = ' . $blog;
								$db->sql_query($sql);
								$sql = 'DELETE FROM ' . ALPHA_BLOG_COMMENTS_TABLE . ' WHERE blog_id = ' . $blog;
								$db->sql_query($sql);
								$sql = 'DELETE FROM ' . ALPHA_BLOG_RATINGS_TABLE . ' WHERE blog_id = ' . $blog;
								$db->sql_query($sql);
							}
							meta_refresh(3, append_sid($phpbb_root_path . 'ucp.' . $phpEx, 'i=alpha_blog&mode=view_all'));
							$redirect = sprintf($user->lang['RETURN_BLOG'], '<a href="' . append_sid($phpbb_root_path . 'ucp.' . $phpEx, 'i=alpha_blog&mode=view_all') . '">', '</a> ');
							trigger_error($user->lang['SUCCESSFUL_DELETE_BLOG'] . $redirect);
						}
						else
						{
							confirm_box(false, $user->lang['CONFIRM_DELETE_BLOG'], build_hidden_fields(array('blogs'	=> $blog_id)));
							meta_refresh(3, $this->u_action . '&b=' . $blog_id);
							$message = $user->lang['RETURN_NO_DELETE_BLOG'] . sprintf($user->lang['RETURN_BLOG'], '<a href="' . $this->u_action . '&b=' . $blog_id . '">', '</a> ');
							trigger_error($message);
						}
					}
				}
				return;
			break;
		}
	}
}

?>