<?php
/**
*
* @package install
* @version $Id: install_readme.php 37 2008-08-02 12:59:42Z harmlessgoat22 $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
*/
if (!defined('IN_INSTALL'))
{
	// Someone has tried to access the file direct. This is not a good idea, so exit
	exit;
}

if (!empty($setmodules))
{
	$module[] = array(
		'module_type'		=> 'install',
		'module_title'		=> 'README',
		'module_filename'	=> substr(basename(__FILE__), 0, -strlen($phpEx)-1),
		'module_order'		=> 40,
		'module_subs'		=> array('QUICKSTART', 'MODULES',/* 'PORTAL',*/ 'SIDEBARS', 'PERMISSIONS'),
		'module_stages'		=> '',
		'module_reqs'		=> ''
	);
}

/**
* Installation
* @package install
*/
class install_readme extends module
{
	function install_readme(&$p_master)
	{
		$this->p_master = &$p_master;
	}

	function main($mode, $sub)
	{
		global $user, $template, $phpbb_root_path, $cache, $db_tools;

		switch ($sub)
		{
			case 'quickstart':
				$this->page_title = $user->lang['SUB_INTRO'];
				$title = $user->lang['SUB_QUICKSTART'];
				$body = $user->lang['QUICKSTART_BODY'];
			break;

			case 'modules':
				$this->page_title = $user->lang['SUB_INTRO'];
				$title = $user->lang['SUB_MODULES'];
				$body = $user->lang['MODULES_BODY'];
			break;

			case 'portal':
				$this->page_title = $user->lang['SUB_INTRO'];
				$title = $user->lang['SUB_PORTAL'];
				$body = $user->lang['PORTAL_BODY'];
			break;

			case 'sidebars':
				$this->page_title = $user->lang['SUB_INTRO'];
				$title = $user->lang['SUB_SIDEBARS'];
				$body = $user->lang['SIDEBARS_BODY'];
			break;

			case 'permissions':
				$this->page_title = $user->lang['SUB_INTRO'];
				$title = $user->lang['SUB_PERMISSIONS'];
				$body = $user->lang['PERMISSIONS_BODY'];
			break;

		}
		$this->tpl_name = 'install_main';
		$this->page_title = $title;

		$template->assign_vars(array(
			'TITLE'		=> $title,
			'BODY'		=> $body,
		));
	}

	/**
	* Adds tables
	*/
	function delete_tables()
	{
		global $db;
		$sql = 'DROP TABLE ' . ALPHA_PAGES_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_PORTAL_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_PORTAL_OPTIONS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_MODULES_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_MODULES_CONFIG_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_SIDEBARS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ACL_ALPHA_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_BLOG_COMMENTS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_BLOG_LABELS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_BLOG_POSTS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_BLOG_POST_LABELS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_BLOG_RATINGS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DELETE FROM ' . CONFIG_TABLE . ' WHERE config_name = alphaportal_enabled';
		$db->sql_query($sql);
	}
}

?>