<?php
/**
*
* @package install
* @version $Id: install_uninstall.php 37 2008-08-02 12:59:42Z harmlessgoat22 $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
*/
if (!defined('IN_INSTALL'))
{
	// Someone has tried to access the file direct. This is not a good idea, so exit
	exit;
}

if (!empty($setmodules))
{
	// If phpBB is already installed we do not include this module
	if (!isset($config['alphaportal_enabled']))
	{
		return;
	}

	$module[] = array(
		'module_type'		=> 'install',
		'module_title'		=> 'UNINSTALL',
		'module_filename'	=> substr(basename(__FILE__), 0, -strlen($phpEx)-1),
		'module_order'		=> 30,
		'module_subs'		=> '',
		'module_stages'		=> array('INTRO', 'FINAL'),
		'module_reqs'		=> ''
	);
}

/**
* Installation
* @package install
*/
class install_uninstall extends module
{
	function install_uninstall(&$p_master)
	{
		$this->p_master = &$p_master;
	}

	function main($mode, $sub)
	{
		global $user, $template, $phpbb_root_path, $cache, $db_tools, $version;

		switch ($sub)
		{
			case 'intro':
				$this->page_title = $user->lang['SUB_INTRO'];

				$template->assign_vars(array(
					'TITLE'			=> $user->lang['UNINSTALL_INTRO'],
					'BODY'			=> $user->lang['UNINSTALL_INTRO_BODY'],
					'L_SUBMIT'		=> $user->lang['UNINSTALL'],
					'U_ACTION'		=> $this->p_master->module_url . "?mode=$mode&amp;sub=final",
				));

			break;

			case 'final':
				//$this->remove_permissions();
				$this->remove_configs();
				//$this->remove_modules_admin();
				$remove_user_blogs = array(
					'drop_columns' => array(
						USERS_TABLE		=> array('user_blogs'),
					),
				);
				$db_tools->perform_schema_changes($remove_user_blogs);
				$this->delete_tables();
				$cache->purge();
				$this->page_title = $user->lang['STAGE_FINAL'];

				$template->assign_vars(array(
					'TITLE'			=> $user->lang['UNINSTALL_CONGRATS'],
					'BODY'			=> sprintf($user->lang['UNINSTALL_CONGRATS_EXPLAIN'], $version),
				));
			break;
		}

		$this->tpl_name = 'install_install';
	}

	/**
	* Deletes the config that says that alphaPORTAL is installed
	*/
	function remove_configs()
	{
		global $db;
		$sql = 'DELETE FROM ' . CONFIG_TABLE . " WHERE config_name IN ('alphaportal_enabled', 'alphaportal_version', 'alphaportal_default_template', 'allow_blog_attach')";
		$db->sql_query($sql);
	}

	/**
	* Adds tables
	*/
	function delete_tables()
	{
		global $db;
		$sql = 'DROP TABLE ' . ALPHA_PAGES_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_PORTAL_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_MODULES_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_MODULES_CONFIG_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_SIDEBARS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ACL_ALPHA_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_BLOG_COMMENTS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_BLOG_LABELS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_BLOG_POSTS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_BLOG_POST_LABELS_TABLE . "; \n";
		$db->sql_query($sql);
		$sql = 'DROP TABLE ' . ALPHA_BLOG_RATINGS_TABLE . "; \n";
		$db->sql_query($sql);
	}
}

?>