<?php
/**
*
* @package alphaPORTAL
* @version $Id: install_alpha.php 4 2008-07-16 01:28:54Z harmlessgoat22 $
* @copyright (c) 2008 phpALPHA Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

if (!defined('IN_PHPBB'))
{
	exit;
}
if (empty($lang) || !is_array($lang))
{
    $lang = array();
}
// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

$lang = array_merge($lang, array(
	'RETURN_INSTALL_ALPHA'		=> "You have chosen to not install alphaPORTAL. You will now be redirected to the index page.<br /><br />",
	'INSTALL_CONFIRM_ALPHA'		=> 'Are you sure you would like to install alphaPORTAL on your forum?',
	'SUCCESSFUL_INSTALL'		=> "AlphaPORTAL's database has been installed successfully! Congratulations! Please continue with the installation by completing the edits if you have not already done so, and adding the alphaPORTAL module to the ACP.<br /><br />",
	'RETURN_UPGRADE_ALPHA'		=> "You have chosen to not upgrade alphaPORTAL. You will now be redirected to the index page.<br /><br />",
	'UPGRADE_CONFIRM'			=> 'Are you sure you would like to upgrade from your current version of alphaPORTAL to the latest?',
	'SUCCESSFUL_UPGRADE'		=> "AlphaPORTAL's database has been upgraded successfully! Congratulations!<br /><br />",
));

$lang = array_merge($lang, array(
	'ENABLE_ALPHA'						=> 'Enable alphaPORTAL',
	'SETTINGS'							=> 'Settings',
	'DEFAULT_PAGE_TEMPLATE'				=> 'Default page template',
	'DEFAULT_PAGE_TEMPLATE_EXPLAIN'		=> 'Which of these three options will be used if \'default\' is selected for a page\'s template?',

	'QUICKSTART_BODY'		=> 'This guide is intended to give you a basic overview of the functions and features of alphaPORTAL, and how to use them. You will learn how to add, remove, edit, and rearrange modules, how to create custom pages, how to change the number of sidebars per page, how to add a page from another MOD into the scope of alphaPORTAL, and how to set permissions for who can view what pages.',
	'MODULES_BODY'			=> "To start off, a module is, in this case, a pluginable block that can be moved around in alphaPORTAL. It can go in the sidebar, or in the middle column. Modules are very versatile, and it is simple to create your own dynamic module. However, this guide will not cover that.<br /><br />Before you can do anything with modules, you have to know where to go. Enter your Administrative Control Panel, then head to the .MODs tab. Once in there, click on 'Module Management'. This is the area for managing modules. On the main page, there are seven different categories. Below, they are all defined<br /><ul><li><strong>Left</strong> - These are the modules that will show in the left sidebar</li><li><strong>Right</strong> - These are the modules that will show in the right sidebar</li><li><strong>Combined</strong> - These modules will show on pages with only one sidebar.</li><li><strong>Index</strong> - These modules will show in the middle column on the index page. Among the modules that should be included in this category is the 'Index' module.</li><li><strong>Portal</strong> - These modules will show in the middle column on the portal page. Among the modules that should be included in this category is the 'Portal' module.</li><li><strong>Custom Pages</strong> - This category can be used to house both custom page modules, and custom page categories. Custom page categories are pages that can have more than one module in the center column. They function similarly to the 'Index' and 'Portal' categories.</li><li><strong>Blog</strong> - This category contains two categories beneath it - User info sidebar, and Main page. User info sidebar is the sidebar that will be shown on the left of all blog pages. Main page holds the center content for all the items that will appear on the main blog page.</li></ul><br />Now that you have a basic outline of the categories, you will learn how to add modules. There are two ways to add modules. You can either use the quickadd toolbar, or type in the name for a module, then go to an advanced editing page. Make sure you select a category to put these modules in first though.<br /><br />Removing modules is simple. Just click the red x next to a module, and confirm that you would like to delete it. As easy as pie.<br /><br />Editing modules is quite simple as well. Just click the green gear next to the module, and you will be taken to a page with many options. If you are editing a custom page, you will have the text body field and the title field, among other things. Other modules will have different editing options. For example, recent posts allows the option of selecting a forum you would like to take posts from. Some modules don't have any custom settings. All modules have the option of disabling them, and changing the title.<br /><h2>Custom Page Categories</h2><br />Custom page categories allow you to make new pages with multiple modules in the center column. This is done very similarily to the 'Index' and 'Portal' categories. You may add a category inside the 'Custom Pages' category by typing a name in the 'Add Module' field, then selecting 'Category' from a dropdown menu on the following page. Add as many or as few modules as you like. Easy as that.<br /><br />Subpages work along the same lines. You add a category in the 'Custom Pages' category, but then, under that category, add ANOTHER category (or two, or three, or four). Each category under that works in the same way as regular Custom Page Categories.",
	'PORTAL_BODY'			=> 'Portal',
	'SIDEBARS_BODY'			=> "New in alphaPORTAL 2.0, you can change the number of sidebars per page in the ACP. Just go to the Settings module in the alphaPORTAL general area. It is also possible to add sidebars (and have a dynamic number of them) to your own pages, both custom pages made by alphaPORTAL, and pages you may wish to add from other MODs. To change the number of sidebars, just select the radio box for the number you want for your page in the Settings page. Custom pages made by alphaPORTAL are automatically added to the list, so you can set how many sidebars for them as well. To add sidebars to your new page, put the following code around the rest of your content.<br /><br /><code>" . htmlspecialchars('<!-- INCLUDE alphaportal/sidebars.html -->
{YOUR_CONTENT}
</div>') . "</code><br /><br />After that, use the simple and easy to use form in the Settings page to add your page to the list. Don't bother about the 'Page id' field. That's all there is to it! Refresh your cache, and you should see the results immediately.",
	'PERMISSIONS_BODY'		=> 'Permissions are quite simple in alphaPORTAL. There aren\'t too many options: let a group see the page, or don\'t. All pages are automatically added and removed from the list when you create or delete a custom page (either advanced or simple page). If a user visits a page (eg pages.php?p=5) that they are not allowed to see, it display a message telling them they do not have the proper permissions.',


	'CAT_CONVERT'				=> 'Convert',
	'CAT_INSTALL'				=> 'Install',
	'CAT_OVERVIEW'				=> 'Overview',
	'CAT_UPDATE'				=> 'Update',

	'DBMS'						=> 'Database type',
	'DB_CONFIG'					=> 'Database configuration',
	'DB_CONNECTION'				=> 'Database connection',
	'DB_ERR_INSERT'				=> 'Error while processing <code>INSERT</code> query.',
	'DB_ERR_LAST'				=> 'Error while processing <var>query_last</var>.',
	'DB_ERR_QUERY_FIRST'		=> 'Error while executing <var>query_first</var>.',
	'DB_ERR_QUERY_FIRST_TABLE'	=> 'Error while executing <var>query_first</var>, %s (%s).',
	'DB_ERR_SELECT'				=> 'Error while running <code>SELECT</code> query.',
	'DLL_MSSQL'					=> 'MSSQL Server 2000+',
	'DLL_MSSQL_ODBC'			=> 'MSSQL Server 2000+ via ODBC',
	'DLL_MYSQL'					=> 'MySQL',
	'DLL_MYSQLI'				=> 'MySQL with MySQLi Extension',
	'DLL_ORACLE'				=> 'Oracle',
	'DLL_POSTGRES'				=> 'PostgreSQL 7.x/8.x',
	'DLL_SQLITE'				=> 'SQLite',
	'DONE'						=> 'Done',

	'GPL'						=> 'General Public License',

	'INSTALL_CONGRATS'			=> 'Congratulations!',
	'INSTALL_CONGRATS_EXPLAIN'	=> '
		<p>You have now successfully installed alphaPORTAL %1$s.</p>',
	'INSTALL_INTRO'				=> 'Welcome to Installation',

	'INSTALL_INTRO_BODY'		=> 'With this option, it is possible to install alphaPORTAL onto your phpBB3 board.</p><p>In order to proceed, you are not required to have completed the edits for alphaPORTAL already. If you have not already done them, after the install you may go back and complete them.</p>',
	'INSTALL_INTRO_NEXT'		=> 'To commence the installation, please press the button below.',
	'INSTALL_LOGIN'				=> 'Login',
	'INSTALL_NEXT'				=> 'Next stage',
	'INSTALL_PANEL'				=> 'Installation Panel',
	'INSTALL_START'				=> 'Start install',
	'INST_ERR_FATAL'			=> 'Fatal installation error',

	'UNINSTALL'						=> 'Uninstall',
	'UNINSTALL_CONGRATS'			=> 'Success!',
	'UNINSTALL_CONGRATS_EXPLAIN'	=> '
		<p>You have now successfully uninstalled alphaPORTAL %1$s.</p>',
	'UNINSTALL_INTRO'				=> 'Uninstall alphaPORTAL',

	'UNINSTALL_INTRO_BODY'		=> '<p>You may now uninstall alphaPORTAL. Please note that uninstallation is permanent and irrevertable. Once you have uninstalled alphaPORTAL, all your data will be lost.</p>',

	'UPGRADE'						=> 'Upgrade',
	'UPGRADE_COMPLETE'				=> 'Success!',
	'UPGRADE_COMPLETE_EXPLAIN'		=> '
		<p>You have now successfully upgraded to the latest version of alphaPORTAL.</p>',
	'UPGRADE_INTRO'					=> 'Upgrade versions of alphaPORTAL',

	'UPGRADE_INTRO_BODY'			=> '<p>If your version of alphaPORTAL is not up-to-date, you may wish to upgrade. Please follow these simples steps to get your copy of alphaPORTAL running to the fullest of its abilities. Note that if you select to upgrade from a version that you may not be using, errors may possibly occur, causing you to lose all your data. Double check to make sure you are indeed running the version you think you are, and also backup your database before proceeding.</p>',
	'UPGRADE_OPTIONS_BODY'			=> 'Please select the version of alphaPORTAL that you wish to upgrade from.',
	'BEGIN_UPGRADE'					=> 'Begin upgrade',
	'OPTIONS'						=> 'Options',

	'IN_PROGRESS_BODY'			=> 'The database has been updated to the most recent version of alphaPORTAL',

	'NEXT_STEP'					=> 'Proceed to next step',
	'NO_TABLES_FOUND'			=> 'No tables found.',

	'OVERVIEW_BODY'				=> 'Welcome to alphaPORTAL!<br /><br />AlphaPORTAL is a simple yet powerful portal for phpBB3. It contains a vast array of features, a list that keeps growing. For information on features and use of alphaPORTAL, we encourage you to read the readme.<br /><br />To read the alphaPORTAL license or learn about obtaining support and our stance on it, please select the respective options from the side menu. To continue, please select the appropriate tab above.',

	'PHP_SUPPORTED_DB'				=> 'Supported databases',
	'PHP_SUPPORTED_DB_EXPLAIN'		=> '<strong>Required</strong> - You must have support for at least one compatible database within PHP. If no database modules are shown as available you should contact your hosting provider or review the relevant PHP installation documentation for advice.',
	'PHP_SETTINGS'					=> 'PHP version and settings',

	'SELECT_LANG'				=> 'Select language',
	'STAGE_CREATE_TABLE'		=> 'Create database tables',
	'STAGE_CREATE_TABLE_EXPLAIN'	=> 'The database tables used by alphaPORTAL 2.0 have been created and populated with some initial data. Proceed to the next screen to finish installing alphaPORTAL.',
	'STAGE_DATABASE'			=> 'Database settings',
	'STAGE_FINAL'				=> 'Final stage',
	'STAGE_INTRO'				=> 'Introduction',
	'STAGE_IN_PROGRESS'			=> 'Conversion in progress',
	'STAGE_REQUIREMENTS'		=> 'Requirements',
	'STAGE_SETTINGS'			=> 'Settings',
	'SUB_QUICKSTART'			=> 'Quickstart',
	'SUB_MODULES'				=> 'Modules',
	'SUB_PORTAL'				=> 'Portal',
	'SUB_SIDEBARS'				=> 'Sidebars',
	'SUB_PERMISSIONS'			=> 'Permissions',
	'SUB_INTRO'					=> 'Introduction',
	'SUB_LICENSE'				=> 'License',
	'SUB_SUPPORT'				=> 'Support',
	'SUPPORT_BODY'				=> 'Full support will be provided for the current stable release of alphaPORTAL, free of charge. This includes:</p><ul><li>installation</li><li>configuration</li><li>technical questions</li><li>problems relating to potential bugs in the software</li><li>updating from Release Candidate (RC) versions to the latest stable version</li><li>converting from alphaPORTAL 1.0.x to alphaPORTAL 2.0.x</li></ul><p>We encourage users still running old versions of alphaPORTAL to replace their installation with a fresh copy of the latest version.</p><h2>Obtaining Support</h2><p><a href="http://alphaportal.net">Official alphaPORTAL Board</a><br /><a href="./index.php?mode=readme&sub=quickstart&language=en">Quick Start Guide</a><br /><br />',

	'VERSION'					=> 'Version',
	'VERSION_EXPLAIN'			=> 'Version',

	'WELCOME_INSTALL'			=> 'Welcome to alphaPORTAL Installation',
));

// Updater
$lang = array_merge($lang, array(
	'ALL_FILES_UP_TO_DATE'		=> 'All files are up to date with the latest alphaPORTAL version. You should now <a href="../ucp.php?mode=login">login to your board</a> and check if everything is working fine. Do not forget to delete, rename or move your install directory!',

	'BACK'				=> 'Back',

	'CHECK_FILES_UP_TO_DATE'		=> 'According to your database your version is up to date. You may want to proceed with the file check to make sure all files are really up to date with the latest alphaPORTAL version.',
	'CHECK_UPDATE_DATABASE'			=> 'Continue update process',
	'COMPLETE_LOGIN_TO_BOARD'		=> 'You should now <a href="../ucp.php?mode=login">login to your board</a> and check if everything is working fine. Do not forget to delete, rename or move your install directory!',
	'CONTINUE_UPDATE_NOW'			=> 'Continue the update process now',
	'CURRENT_VERSION'				=> 'Current version',

	'DATABASE_TYPE'						=> 'Database type',
	'DATABASE_UPDATE_INFO_OLD'			=> 'The database update file within the install directory is outdated. Please make sure you uploaded the correct version of the file.',

	'ERROR'			=> 'Error',

	'INLINE_UPDATE_SUCCESSFUL'		=> 'The database update was successful. Now you need to continue the update process.',

	'LATEST_VERSION'		=> 'Latest version',

	'NO_UPDATE_FILES_UP_TO_DATE'	=> 'Your version is up to date. There is no need to run the update tool. If you want to make an integrity check on your files make sure you uploaded the correct update files.',
	'NO_UPDATES_REQUIRED'			=> 'No updates required',
	'NOTICE'						=> 'Notice',

	'OLD_UPDATE_FILES'		=> 'Update files are out of date. The update files found are for updating from alphaPORTAL %1$s to alphaPORTAL %2$s but the latest version of alphaPORTAL is %3$s.',

	'PACKAGE_UPDATES_TO'				=> 'Current package updates to version',
	'PERFORM_DATABASE_UPDATE'			=> 'Perform database update',
	'PERFORM_DATABASE_UPDATE_EXPLAIN'	=> 'Below you will find a button to the database update script. The database update can take a while, so please do not stop the execution if it seems to hang. After the database update has been performed just follow the instructions to continue the update process.',
	'PREVIOUS_VERSION'					=> 'Previous version',
	'PROGRESS'							=> 'Progress',

	'RESULT'					=> 'Result',
	'RUN_DATABASE_SCRIPT'		=> 'Update my database now',

	'UPDATE_COMPLETED'				=> 'Update completed',
	'UPDATE_DATABASE'				=> 'Update database',
	'UPDATE_DATABASE_EXPLAIN'		=> 'Within the next step the database will be updated.',
	'UPDATE_DATABASE_SCHEMA'		=> 'Updating database schema',
	'UPDATE_FILES'					=> 'Update files',
	'UPDATE_FILES_NOTICE'			=> 'Please make sure you have updated your board files too, this file is only updating your database.',
	'UPDATE_INSTALLATION'			=> 'Update alphaPORTAL installation',
	'UPDATE_INSTALLATION_EXPLAIN'	=> 'With this option, it is possible to update your alphaPORTAL installation to the latest version.<br />During the process all of your files will be checked for their integrity. You are able to review all differences and files before the update.<br /><br />The file update itself can be done in two different ways.</p><h2>Manual Update</h2><p>With this update you only download your personal set of changed files to make sure you do not lose your file modifications you may have done. After you downloaded this package you need to manually upload the files to their correct position under your phpBB root directory. Once done, you are able to do the file check stage again to see if you moved the files to their correct location.</p><h2>Automatic Update with FTP</h2><p>This method is similar to the first one but without the need to download the changed files and uploading them on your own. This will be done for you. In order to use this method you need to know your FTP login details since you will be asked for them. Once finished you will be redirected to the file check again to make sure everything got updated correctly.<br /><br />',
	'UPDATE_INSTRUCTIONS'			=> '

		<h1>Release announcement</h1>

		<p>Please read <a href="%1$s" title="%1$s"><strong>the release announcement for the latest version</strong></a> before you continue your update process, it may contain useful information. It also contains full download links as well as the change log.</p>

		<br />

		<h1>How to update your installation with the Automatic Update Package</h1>

		<p>The recommended way of updating your installation listed here is only valid for the automatic update package. You are also able to update your installation using the methods listed within the INSTALL.html document. The steps for updating phpBB3 automatically are:</p>

		<ul style="margin-left: 20px; font-size: 1.1em;">
			<li>Go to the <a href="http://www.phpbb.com/downloads/" title="http://www.phpbb.com/downloads/">phpBB.com downloads page</a> and download the "Automatic Update Package" archive.<br /><br /></li>
			<li>Unpack the archive.<br /><br /></li>
			<li>Upload the complete uncompressed install folder to your phpBB root directory (where your config.php file is).<br /><br /></li>
		</ul>

		<p>Once uploaded your board will be offline for normal users due to the install directory you uploaded now present.<br /><br />
		<strong><a href="%2$s" title="%2$s">Now start the update process by pointing your browser to the install folder</a>.</strong><br />
		<br />
		You will then be guided through the update process. You will be notified once the update is complete.
		</p>
	',
	'UPDATE_SUCCESS'				=> 'Update was successful',
	'UPDATE_DB_SUCCESS'				=> 'Database update was successful.',

	'VERSION_CHECK'				=> 'Version check',
	'VERSION_CHECK_EXPLAIN'		=> 'Checks to see if the version of phpBB you are currently running is up to date.',
	'VERSION_NOT_UP_TO_DATE'	=> 'Your version of phpBB is not up to date. Please continue the update process.',
	'VERSION_NOT_UP_TO_DATE_ACP'=> 'Your version of phpBB is not up to date.<br />Below you will find a link to the release announcement for the latest version as well as instructions on how to perform the update.',
	'VERSION_UP_TO_DATE'		=> 'Your installation is up to date, no updates are available for your version of phpBB. You may want to continue anyway to perform a file validity check.',
	'VERSION_UP_TO_DATE_ACP'	=> 'Your installation is up to date, no updates are available for your version of phpBB. You do not need to update your installation.',
	'VIEWING_FILE_CONTENTS'		=> 'Viewing file contents',
	'VIEWING_FILE_DIFF'			=> 'Viewing file differences',

	'WRONG_INFO_FILE_FORMAT'	=> 'Wrong info file format',
));

?>