<?php
/**
*
* @package alphaPORTAL
* @version $Id: pages.php 47 2008-08-06 23:24:21Z harmlessgoat22 $
* @copyright (c) 2008 phpALPHA Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/alpha');

if (!$alphaportal_enabled)
{
	trigger_error('PORTAL_NOT_ENABLED');
}

// Get page_id, but as a MOD validator, I'm sure you already knew that, Mr. Smarty-Pants - oh, and although blog.php is over, Francis is still a nub
$page_id = request_var('p', 0);

// Display all module-based pages if page_id is 0
if ($page_id == 0)
{
	$sql = 'SELECT *
		FROM ' . ALPHA_PAGES_TABLE . '
		ORDER BY title DESC';
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		if (acl_module($row['page_id']))
		{
			$content = generate_text_for_display($row['content'], $row['bbcode_uid'], $row['bbcode_bitfield'], $row['bbcode_options']);
			$style = ($row['style'] == 0) ? $config['alphaportal_default_template'] : $row['style'];
			$template->assign_block_vars('view_page', array(
				'TITLE'	 			=> $row['title'],
				'CONTENT'	 		=> $content,
				'U_PAGE'			=> append_sid("{$phpbb_root_path}pages.{$phpEx}", 'p=' . $row['page_id']),
				'PAGE_STYLE'		=> $style,
				'S_BULL'			=> true
			));
			$template->assign_var('S_VIEW_ONE_PAGE', true);

			if (!isset($title))
			{
				$title = $row['title'];
			}
			else
			{
				$title = $title . " &bull; " . $row['title'];
			}
		}
	}
	$db->sql_freeresult($result);
}
else
{
	// Check if $page_id is a valid advanced page
	$page_results = page_exists($page_id);

	// If not, select simple page from db
	if (!$page_results)
	{
		// Check if authorized
		if (acl_module($page_id))
		{
			// If yes, select page info from db
			$sql = 'SELECT title, content, bbcode_uid, bbcode_bitfield, bbcode_options, style
				FROM ' . ALPHA_PAGES_TABLE . '
				WHERE page_id = ' . $page_id;
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			if (!$row)
			{
				trigger_error('PAGE_NO_EXIST');
			}

			$content = generate_text_for_display($row['content'], $row['bbcode_uid'], $row['bbcode_bitfield'], $row['bbcode_options']);

			$style = ($row['style'] == 0) ? $config['alphaportal_default_template'] : $row['style'];
			$template->assign_block_vars('view_page', array(
				'TITLE'	 			=> $row['title'],
				'CONTENT'		 	=> $content,
				'U_PAGE'			=> append_sid("{$phpbb_root_path}pages.{$phpEx}", 'p=' . $page_id),
				'PAGE_STYLE'		=> $style,
				'S_BULL'			=> true
			));
			$template->assign_var('S_VIEW_ONE_PAGE', true);
			$title = $row['title'];
		}
		else
		{
			// Naughty, naughty...you shouldn't be here!
			trigger_error('NO_AUTH_PAGE');
		}
	}
	else
	{
		// If it is an advanced page, get info about it from the ACP, for use in the header, and perhaps the menu...I forget
		$sql = 'SELECT module_langname, parent_id, left_id, right_id
			FROM ' . ALPHA_MODULES_TABLE . "
			WHERE module_basename = '' AND module_id = " . $page_id;
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		// Well, just because it's not a simple page doesn't mean it's an advanced page. It could also be a "Page not found" page.
		if (!$row)
		{
			trigger_error('PAGE_NO_EXIST');
		}

		$title = (isset($user->lang[$row['module_langname']])) ? $user->lang[$row['module_langname']] : $row['module_langname'];

		// No wait! Now I remember. This part gets the little thing like phpBB does with the forums for the navlinks.
		$sql = 'SELECT module_langname, parent_id, module_id
			FROM ' . ALPHA_MODULES_TABLE . '
			WHERE left_id < ' . $row['left_id'] . ' AND right_id > ' . $row['right_id'] . ' AND module_id <> 6';
		$result_par = $db->sql_query($sql);

		while ($parent_row = $db->sql_fetchrow($result_par))
		{
			$template->assign_block_vars('view_page', array(
				'TITLE'	 			=> (isset($user->lang[$parent_row['module_langname']])) ? $user->lang[$parent_row['module_langname']] : $parent_row['module_langname'],
				'U_PAGE'			=> append_sid("{$phpbb_root_path}pages.{$phpEx}", 'p=' . $parent_row['module_id']),
				'S_BULL'			=> false
			));
		}
		$db->sql_freeresult($result_par);

		$template->assign_block_vars('view_page', array(
			'TITLE'	 			=> $title,
			'U_PAGE'			=> append_sid("{$phpbb_root_path}pages.{$phpEx}", 'p=' . $page_id),
			'S_BULL'			=> false
		));
	}
}

// Output the page
page_header($title);

if ($page_id <> 0)
{
	$page_results = include_sidebar('pages', $page_id);
}

$template->set_filenames(array(
	'body' => 'pages_body.html')
);

page_footer();

?>